/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/base/common/diff/diffChange",["require","exports"],function(e,t){"use strict";t.DifferenceType={Add:0,Remove:1,Change:2};var n=function(){function e(e,t,n,r){this.originalStart=e,this.originalLength=t,this.modifiedStart=n,this.modifiedLength=r}return e.prototype.getChangeType=function(){return 0===this.originalLength?t.DifferenceType.Add:0===this.modifiedLength?t.DifferenceType.Remove:t.DifferenceType.Change},e.prototype.getOriginalEnd=function(){return this.originalStart+this.originalLength},e.prototype.getModifiedEnd=function(){return this.modifiedStart+this.modifiedLength},e}();t.DiffChange=n}),define("vs/base/common/diff/diff",["require","exports","vs/base/common/diff/diffChange"],function(e,t,n){"use strict";var r=function(){function e(){}return e.Assert=function(e,t){if(!e)throw new Error(t)},e}();t.Debug=r;var i=function(){function e(){}return e.Copy=function(e,t,n,r,i){for(var o=0;i>o;o++)n[r+o]=e[t+o]},e}();t.MyArray=i;var o=1447,u=function(){function e(){this.m_changes=[],this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE,this.m_originalCount=0,this.m_modifiedCount=0}return e.prototype.MarkNextChange=function(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new n.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=Number.MAX_VALUE,this.m_modifiedStart=Number.MAX_VALUE},e.prototype.AddOriginalElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_originalCount++},e.prototype.AddModifiedElement=function(e,t){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,t),this.m_modifiedCount++},e.prototype.getChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes},e.prototype.getReverseChanges=function(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes},e}(),s=function(){function e(e,t,n){void 0===n&&(n=null),this.OriginalSequence=e,this.ModifiedSequence=t,this.ContinueProcessingPredicate=n,this.m_originalIds=[],this.m_modifiedIds=[],this.m_forwardHistory=[],this.m_reverseHistory=[],this.ComputeUniqueIdentifiers()}return e.prototype.ComputeUniqueIdentifiers=function(){var e=this.OriginalSequence.getLength(),t=this.ModifiedSequence.getLength();this.m_originalIds=new Array(e),this.m_modifiedIds=new Array(t);var n,r={},i=1;for(n=0;e>n;n++){var o=this.OriginalSequence.getElementHash(n);r.hasOwnProperty(o)?this.m_originalIds[n]=r[o]:(this.m_originalIds[n]=i++,r[o]=this.m_originalIds[n])}for(n=0;t>n;n++){var u=this.ModifiedSequence.getElementHash(n);r.hasOwnProperty(u)?this.m_modifiedIds[n]=r[u]:(this.m_modifiedIds[n]=i++,r[u]=this.m_modifiedIds[n])}},e.prototype.ElementsAreEqual=function(e,t){return this.m_originalIds[e]===this.m_modifiedIds[t]},e.prototype.ComputeDiff=function(){return this._ComputeDiff(0,this.OriginalSequence.getLength()-1,0,this.ModifiedSequence.getLength()-1)},e.prototype._ComputeDiff=function(e,t,n,r){var i=[!1];return this.ComputeDiffRecursive(e,t,n,r,i)},e.prototype.ComputeDiffRecursive=function(e,t,i,o,u){for(u[0]=!1;t>=e&&o>=i&&this.ElementsAreEqual(e,i);)e++,i++;for(;t>=e&&o>=i&&this.ElementsAreEqual(t,o);)t--,o--;if(e>t||i>o){var s=void 0;return o>=i?(r.Assert(e===t+1,"originalStart should only be one more than originalEnd"),s=[new n.DiffChange(e,0,i,o-i+1)]):t>=e?(r.Assert(i===o+1,"modifiedStart should only be one more than modifiedEnd"),s=[new n.DiffChange(e,t-e+1,i,0)]):(r.Assert(e===t+1,"originalStart should only be one more than originalEnd"),r.Assert(i===o+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}var a=[0],l=[0],h=this.ComputeRecursionPoint(e,t,i,o,a,l,u),m=a[0],f=l[0];if(null!==h)return h;if(!u[0]){var d=this.ComputeDiffRecursive(e,m,i,f,u),c=[];return c=u[0]?[new n.DiffChange(m+1,t-(m+1)+1,f+1,o-(f+1)+1)]:this.ComputeDiffRecursive(m+1,t,f+1,o,u),this.ConcatenateChanges(d,c)}return[new n.DiffChange(e,t-e+1,i,o-i+1)]},e.prototype.WALKTRACE=function(e,t,r,i,o,s,a,l,h,m,f,d,c,g,p,v,b,C){var _,y=null,L=null,N=new u,S=t,x=r,w=c[0]-v[0]-i,E=Number.MIN_VALUE,A=this.m_forwardHistory.length-1;do _=w+e,_===S||x>_&&h[_-1]<h[_+1]?(f=h[_+1],g=f-w-i,E>f&&N.MarkNextChange(),E=f,N.AddModifiedElement(f+1,g),w=_+1-e):(f=h[_-1]+1,g=f-w-i,E>f&&N.MarkNextChange(),E=f-1,N.AddOriginalElement(f,g+1),w=_-1-e),A>=0&&(h=this.m_forwardHistory[A],e=h[0],S=1,x=h.length-1);while(--A>=-1);if(y=N.getReverseChanges(),C[0]){var M=c[0]+1,I=v[0]+1;if(null!==y&&y.length>0){var R=y[y.length-1];M=Math.max(M,R.getOriginalEnd()),I=Math.max(I,R.getModifiedEnd())}L=[new n.DiffChange(M,d-M+1,I,p-I+1)]}else{N=new u,S=s,x=a,w=c[0]-v[0]-l,E=Number.MAX_VALUE,A=b?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do _=w+o,_===S||x>_&&m[_-1]>=m[_+1]?(f=m[_+1]-1,g=f-w-l,f>E&&N.MarkNextChange(),E=f+1,N.AddOriginalElement(f+1,g+1),w=_+1-o):(f=m[_-1],g=f-w-l,f>E&&N.MarkNextChange(),E=f,N.AddModifiedElement(f+1,g+1),w=_-1-o),A>=0&&(m=this.m_reverseHistory[A],o=m[0],S=1,x=m.length-1);while(--A>=-1);L=N.getChanges()}return this.ConcatenateChanges(y,L)},e.prototype.ComputeRecursionPoint=function(e,t,r,u,s,a,l){var h,m,f,d=0,c=0,g=0,p=0;e--,r--,s[0]=0,a[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];var v=t-e+(u-r),b=v+1,C=new Array(b),_=new Array(b),y=u-r,L=t-e,N=e-r,S=t-u,x=L-y,w=x%2===0;C[y]=e,_[L]=t,l[0]=!1;var E,A;for(f=1;v/2+1>=f;f++){var M=0,I=0;for(d=this.ClipDiagonalBound(y-f,f,y,b),c=this.ClipDiagonalBound(y+f,f,y,b),E=d;c>=E;E+=2){for(h=E===d||c>E&&C[E-1]<C[E+1]?C[E+1]:C[E-1]+1,m=h-(E-y)-N,A=h;t>h&&u>m&&this.ElementsAreEqual(h+1,m+1);)h++,m++;if(C[E]=h,h+m>M+I&&(M=h,I=m),!w&&Math.abs(E-L)<=f-1&&h>=_[E])return s[0]=h,a[0]=m,A<=_[E]&&o>0&&o+1>=f?this.WALKTRACE(y,d,c,N,L,g,p,S,C,_,h,t,s,m,u,a,w,l):null}var R=(M-e+(I-r)-f)/2;if(null!==this.ContinueProcessingPredicate&&!this.ContinueProcessingPredicate(M,this.OriginalSequence,R))return l[0]=!0,s[0]=M,a[0]=I,R>0&&o>0&&o+1>=f?this.WALKTRACE(y,d,c,N,L,g,p,S,C,_,h,t,s,m,u,a,w,l):(e++,r++,[new n.DiffChange(e,t-e+1,r,u-r+1)]);for(g=this.ClipDiagonalBound(L-f,f,L,b),p=this.ClipDiagonalBound(L+f,f,L,b),E=g;p>=E;E+=2){for(h=E===g||p>E&&_[E-1]>=_[E+1]?_[E+1]-1:_[E-1],m=h-(E-L)-S,A=h;h>e&&m>r&&this.ElementsAreEqual(h,m);)h--,m--;if(_[E]=h,w&&Math.abs(E-y)<=f&&h<=C[E])return s[0]=h,a[0]=m,A>=C[E]&&o>0&&o+1>=f?this.WALKTRACE(y,d,c,N,L,g,p,S,C,_,h,t,s,m,u,a,w,l):null}if(o>=f){var P=new Array(c-d+2);P[0]=y-d+1,i.Copy(C,d,P,1,c-d+1),this.m_forwardHistory.push(P),P=new Array(p-g+2),P[0]=L-g+1,i.Copy(_,g,P,1,p-g+1),this.m_reverseHistory.push(P)}}return this.WALKTRACE(y,d,c,N,L,g,p,S,C,_,h,t,s,m,u,a,w,l)},e.prototype.ConcatenateChanges=function(e,t){var n=[],r=null;return 0===e.length||0===t.length?t.length>0?t:e:this.ChangesOverlap(e[e.length-1],t[0],n)?(r=new Array(e.length+t.length-1),i.Copy(e,0,r,0,e.length-1),r[e.length-1]=n[0],i.Copy(t,1,r,e.length,t.length-1),r):(r=new Array(e.length+t.length),i.Copy(e,0,r,0,e.length),i.Copy(t,0,r,e.length,t.length),r)},e.prototype.ChangesOverlap=function(e,t,i){if(r.Assert(e.originalStart<=t.originalStart,"Left change is not less than or equal to right change"),r.Assert(e.modifiedStart<=t.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=t.originalStart||e.modifiedStart+e.modifiedLength>=t.modifiedStart){var o=e.originalStart,u=e.originalLength,s=e.modifiedStart,a=e.modifiedLength;return e.originalStart+e.originalLength>=t.originalStart&&(u=t.originalStart+t.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=t.modifiedStart&&(a=t.modifiedStart+t.modifiedLength-e.modifiedStart),i[0]=new n.DiffChange(o,u,s,a),!0}return i[0]=null,!1},e.prototype.ClipDiagonalBound=function(e,t,n,r){if(e>=0&&r>e)return e;var i=n,o=r-n-1,u=t%2===0;if(0>e){var s=i%2===0;return u===s?0:1}var a=o%2===0;return u===a?r-1:r-2},e}();t.LcsDiff=s}),define("vs/base/common/filters",["require","exports","vs/base/common/strings"],function(e,t,n){"use strict";function r(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=0,i=e.length;i>r;r++){var o=e[r](t,n);if(o)return o}return null}}function i(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return function(t,n){for(var r=[],i=0,o=e.length;o>i;i++){var u=e[i](t,n);if(!u)return null;r=r.concat(u)}return r}}function o(e,t,n){if(!n||0===n.length||n.length<t.length)return null;e&&(t=t.toLowerCase(),n=n.toLowerCase());for(var r=0;r<t.length;r++)if(t[r]!==n[r])return null;return t.length>0?[{start:0,end:t.length}]:[]}function u(e,t){var n=t.toLowerCase().indexOf(e.toLowerCase());return-1===n?null:[{start:n,end:n+e.length}]}function s(e,t){return a(e.toLowerCase(),t.toLowerCase(),0,0)}function a(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]===t[r]){var i=null;if(i=a(e,t,n+1,r+1))return c({start:r,end:r+1},i)}return a(e,t,n,r+1)}function l(e){return e>=97&&122>=e}function h(e){return e>=65&&90>=e}function m(e){return e>=48&&57>=e}function f(e){return[32,9,10,13].indexOf(e)>-1}function d(e){return l(e)||h(e)||m(e)}function c(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function g(e,t){for(var n=t;n<e.length;n++){var r=e.charCodeAt(n);if(h(r)||m(r)||n>0&&!d(e.charCodeAt(n-1)))return n}return e.length}function p(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;var i=null,o=r+1;for(i=p(e,t,n+1,r+1);!i&&(o=g(t,o))<t.length;)i=p(e,t,n+1,o),o++;return null===i?null:c({start:r,end:r+1},i)}function v(e){if(e.length>60)return!1;for(var t=0,n=0,r=0,i=0,o=0,u=0;u<e.length;u++)o=e.charCodeAt(u),h(o)&&t++,l(o)&&n++,d(o)&&r++,m(o)&&i++;var s=t/e.length,a=n/e.length,f=r/e.length,c=i/e.length;return a>.2&&.8>s&&f>.6&&.2>c}function b(e){for(var t=0,n=0,r=0,i=0,o=0;o<e.length;o++)r=e.charCodeAt(o),h(r)&&t++,l(r)&&n++,f(r)&&i++;return 0!==t&&0!==n||0!==i?5>=t:e.length<=30}function C(e,t){if(!t||0===t.length)return null;if(!b(e))return null;if(!v(t))return null;for(var n=null,r=0;r<t.length&&null===(n=p(e.toLowerCase(),t,0,r));)r=g(t,r+1);return n}function _(e,t){if(!t||0===t.length)return null;for(var n=null,r=0;r<t.length&&null===(n=y(e.toLowerCase(),t,0,r));)r=L(t,r+1);return n}function y(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;var i=null,o=r+1;for(i=y(e,t,n+1,r+1);!i&&(o=L(t,o))<t.length;)i=y(e,t,n+1,o),o++;return null===i?null:c({start:r,end:r+1},i)}function L(e,t){for(var n=t;n<e.length;n++){var r=e.charCodeAt(n);if(f(r)||n>0&&f(e.charCodeAt(n-1)))return n}return e.length}function N(e,r,i){if(void 0===i&&(i=!1),"string"!=typeof e||"string"!=typeof r)return null;var o=x[e];o||(o=new RegExp(n.convertSimple2RegExpPattern(e),"i"),x[e]=o);var u=o.exec(r);return u?[{start:u.index,end:u.index+u[0].length}]:i?S(e,r):t.fuzzyContiguousFilter(e,r)}t.or=r,t.and=i,t.matchesStrictPrefix=function(e,t){return o(!1,e,t)},t.matchesPrefix=function(e,t){return o(!0,e,t)},t.matchesContiguousSubString=u,t.matchesSubString=s,t.matchesCamelCase=C,t.matchesWords=_,function(e){e[e.Contiguous=0]="Contiguous",e[e.Separate=1]="Separate"}(t.SubstringMatching||(t.SubstringMatching={}));t.SubstringMatching;t.fuzzyContiguousFilter=r(t.matchesPrefix,C,u);var S=r(t.matchesPrefix,C,s),x={};t.matchesFuzzy=N}),define("vs/base/common/uri",["require","exports","vs/base/common/platform"],function(e,t,n){"use strict";function r(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()}function i(e){return encodeURIComponent(e).replace(/[!'()*]/g,r)}function o(e){return e}var u=function(){function e(){this._scheme=e._empty,this._authority=e._empty,this._path=e._empty,this._query=e._empty,this._fragment=e._empty,this._formatted=null,this._fsPath=null}return Object.defineProperty(e.prototype,"scheme",{get:function(){return this._scheme},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"authority",{get:function(){return this._authority},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"query",{get:function(){return this._query},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fragment",{get:function(){return this._fragment},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fsPath",{get:function(){if(!this._fsPath){var t;t=this._authority&&"file"===this.scheme?"//"+this._authority+this._path:e._driveLetterPath.test(this._path)?this._path[1].toLowerCase()+this._path.substr(2):this._path,n.isWindows&&(t=t.replace(/\//g,"\\")),this._fsPath=t}return this._fsPath},enumerable:!0,configurable:!0}),e.prototype["with"]=function(t,n,r,i,o){var u=new e;return u._scheme=t||this.scheme,u._authority=n||this.authority,u._path=r||this.path,u._query=i||this.query,u._fragment=o||this.fragment,e._validate(u),u},e.prototype.withScheme=function(e){return this["with"](e,void 0,void 0,void 0,void 0)},e.prototype.withAuthority=function(e){return this["with"](void 0,e,void 0,void 0,void 0)},e.prototype.withPath=function(e){return this["with"](void 0,void 0,e,void 0,void 0)},e.prototype.withQuery=function(e){return this["with"](void 0,void 0,void 0,e,void 0)},e.prototype.withFragment=function(e){return this["with"](void 0,void 0,void 0,void 0,e)},e.parse=function(t){var n=new e,r=e._parseComponents(t);return n._scheme=r.scheme,n._authority=decodeURIComponent(r.authority),n._path=decodeURIComponent(r.path),n._query=decodeURIComponent(r.query),n._fragment=decodeURIComponent(r.fragment),e._validate(n),n},e.file=function(t){var n=new e;if(n._scheme="file",t=t.replace(/\\/g,e._slash),t[0]===e._slash&&t[0]===t[1]){var r=t.indexOf(e._slash,2);-1===r?n._authority=t.substring(2):(n._authority=t.substring(2,r),n._path=t.substring(r))}else n._path=t;return n._path[0]!==e._slash&&(n._path=e._slash+n._path),e._validate(n),n},e._parseComponents=function(t){var n={scheme:e._empty,authority:e._empty,path:e._empty,query:e._empty,fragment:e._empty},r=e._regexp.exec(t);return r&&(n.scheme=r[2]||n.scheme,n.authority=r[4]||n.authority,n.path=r[5]||n.path,n.query=r[7]||n.query,n.fragment=r[9]||n.fragment),n},e.create=function(t,n,r,i,o){return(new e)["with"](t,n,r,i,o)},e._validate=function(e){if(e.authority&&e.path&&"/"!==e.path[0])throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character');if(!e.authority&&0===e.path.indexOf("//"))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')},e.prototype.toString=function(t){return void 0===t&&(t=!1),t?e._asFormatted(this,!0):(this._formatted||(this._formatted=e._asFormatted(this,!1)),this._formatted)},e._asFormatted=function(t,n){var u=n?o:i,s=[],a=t.scheme,l=t.authority,h=t.path,m=t.query,f=t.fragment;if(a&&s.push(a,":"),(l||"file"===a)&&s.push("//"),l){l=l.toLowerCase();var d=l.indexOf(":");-1===d?s.push(u(l)):s.push(u(l.substr(0,d)),l.substr(d))}if(h){var c=e._upperCaseDrive.exec(h);c&&(h=c[1]+c[2].toLowerCase()+h.substr(c[1].length+c[2].length));for(var g=0;;){var d=h.indexOf(e._slash,g);if(-1===d){s.push(u(h.substring(g)).replace(/[#?]/,r));break}s.push(u(h.substring(g,d)).replace(/[#?]/,r),e._slash),g=d+1}}return m&&s.push("?",u(m)),f&&s.push("#",u(f)),s.join(e._empty)},e.prototype.toJSON=function(){return{scheme:this.scheme,authority:this.authority,path:this.path,fsPath:this.fsPath,query:this.query,fragment:this.fragment.replace(/URL_MARSHAL_REMOVE.*$/,""),external:this.toString().replace(/#?URL_MARSHAL_REMOVE.*$/,""),$mid:1}},e.revive=function(t){var n=new e;return n._scheme=t.scheme,n._authority=t.authority,n._path=t.path,n._query=t.query,n._fragment=t.fragment,n._fsPath=t.fsPath,n._formatted=t.external,e._validate(n),n},e._empty="",e._slash="/",e._regexp=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,e._driveLetterPath=/^\/[a-zA-z]:/,e._upperCaseDrive=/^(\/)?([A-Z]:)/,e}();Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=u}),define("vs/editor/common/core/arrays",["require","exports"],function(e,t){"use strict";var n;!function(e){function t(e,t){var n=0,r=e.length-1;if(0>=r)return 0;for(;r>n;){var i=n+Math.ceil((r-n)/2);e[i].startIndex>t?r=i-1:n=i}return n}e.findIndexInSegmentsArray=t}(n=t.Arrays||(t.Arrays={}))}),define("vs/editor/common/core/modeTransition",["require","exports","vs/editor/common/core/arrays"],function(e,t,n){"use strict";var r=function(){function e(e,t){this.startIndex=0|e,this.mode=t}return e.findIndexInSegmentsArray=function(e,t){return n.Arrays.findIndexInSegmentsArray(e,t)},e.create=function(t){for(var n=[],r=0,i=t.length;i>r;r++){var o=t[r];n.push(new e(o.startIndex,o.mode))}return n},e}();t.ModeTransition=r}),define("vs/editor/common/core/position",["require","exports"],function(e,t){"use strict";var n=function(){function e(e,t){this.lineNumber=0|e,this.column=0|t}return e.prototype.equals=function(t){return e.equals(this,t)},e.equals=function(e,t){return e||t?!!e&&!!t&&e.lineNumber===t.lineNumber&&e.column===t.column:!0},e.prototype.isBefore=function(t){return e.isBefore(this,t)},e.isBefore=function(e,t){return e.lineNumber<t.lineNumber?!0:t.lineNumber<e.lineNumber?!1:e.column<t.column},e.prototype.isBeforeOrEqual=function(t){return e.isBeforeOrEqual(this,t)},e.isBeforeOrEqual=function(e,t){return e.lineNumber<t.lineNumber?!0:t.lineNumber<e.lineNumber?!1:e.column<=t.column},e.prototype.clone=function(){return new e(this.lineNumber,this.column)},e.prototype.toString=function(){return"("+this.lineNumber+","+this.column+")"},e.lift=function(t){return new e(t.lineNumber,t.column)},e.isIPosition=function(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column},e.asEmptyRange=function(e){return{startLineNumber:e.lineNumber,startColumn:e.column,endLineNumber:e.lineNumber,endColumn:e.column}},e.startPosition=function(e){return{lineNumber:e.startLineNumber,column:e.startColumn}},e.endPosition=function(e){return{lineNumber:e.endLineNumber,column:e.endColumn}},e}();t.Position=n}),define("vs/editor/common/core/range",["require","exports","vs/editor/common/core/position"],function(e,t,n){"use strict";var r=function(){function e(e,t,n,r){e>n||e===n&&t>r?(this.startLineNumber=n,this.startColumn=r,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=n,this.endColumn=r)}return e.prototype.isEmpty=function(){return e.isEmpty(this)},e.prototype.containsPosition=function(t){return e.containsPosition(this,t)},e.prototype.containsRange=function(t){return e.containsRange(this,t)},e.prototype.plusRange=function(t){return e.plusRange(this,t)},e.prototype.intersectRanges=function(t){return e.intersectRanges(this,t)},e.prototype.equalsRange=function(t){return e.equalsRange(this,t)},e.prototype.getEndPosition=function(){return new n.Position(this.endLineNumber,this.endColumn)},e.prototype.getStartPosition=function(){return new n.Position(this.startLineNumber,this.startColumn)},e.prototype.cloneRange=function(){return new e(this.startLineNumber,this.startColumn,this.endLineNumber,this.endColumn)},e.prototype.toString=function(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"},e.prototype.setEndPosition=function(t,n){return new e(this.startLineNumber,this.startColumn,t,n)},e.prototype.setStartPosition=function(t,n){return new e(t,n,this.endLineNumber,this.endColumn)},e.prototype.collapseToStart=function(){return new e(this.startLineNumber,this.startColumn,this.startLineNumber,this.startColumn)},e.lift=function(t){return t?new e(t.startLineNumber,t.startColumn,t.endLineNumber,t.endColumn):null},e.isIRange=function(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn},e.isEmpty=function(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn},e.containsPosition=function(e,t){return t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber?!1:t.lineNumber===e.startLineNumber&&t.column<e.startColumn?!1:!(t.lineNumber===e.endLineNumber&&t.column>e.endColumn)},e.containsRange=function(e,t){return t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber?!1:t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber?!1:t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn?!1:!(t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn)},e.areIntersectingOrTouching=function(e,t){return e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn?!1:!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn)},e.intersectRanges=function(t,n){var r=t.startLineNumber,i=t.startColumn,o=t.endLineNumber,u=t.endColumn,s=n.startLineNumber,a=n.startColumn,l=n.endLineNumber,h=n.endColumn;return s>r?(r=s,i=a):r===s&&(i=Math.max(i,a)),o>l?(o=l,u=h):o===l&&(u=Math.min(u,h)),r>o?null:r===o&&i>u?null:new e(r,i,o,u)},e.plusRange=function(t,n){var r,i,o,u;return n.startLineNumber<t.startLineNumber?(r=n.startLineNumber,i=n.startColumn):n.startLineNumber===t.startLineNumber?(r=n.startLineNumber,i=Math.min(n.startColumn,t.startColumn)):(r=t.startLineNumber,i=t.startColumn),n.endLineNumber>t.endLineNumber?(o=n.endLineNumber,u=n.endColumn):n.endLineNumber===t.endLineNumber?(o=n.endLineNumber,u=Math.max(n.endColumn,t.endColumn)):(o=t.endLineNumber,u=t.endColumn),new e(r,i,o,u)},e.equalsRange=function(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn},e.compareRangesUsingStarts=function(e,t){var n=0|e.startLineNumber,r=0|t.startLineNumber,i=0|e.startColumn,o=0|t.startColumn,u=0|e.endLineNumber,s=0|t.endLineNumber,a=0|e.endColumn,l=0|t.endColumn;return n===r?i===o?u===s?a-l:u-s:i-o:n-r},e.compareRangesUsingEnds=function(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber},e.spansMultipleLines=function(e){return e.endLineNumber>e.startLineNumber},e.collapseToStart=function(e){return{startLineNumber:e.startLineNumber,startColumn:e.startColumn,endLineNumber:e.startLineNumber,endColumn:e.startColumn}},e}();t.Range=r});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/diff/diffComputer",["require","exports","vs/base/common/diff/diff","vs/base/common/strings"],function(e,t,n,r){"use strict";function i(e,t,r){var i=new n.LcsDiff(e,t,r);return i.ComputeDiff()}function o(e){if(e.length<=1)return e;var t,n,r,i,o,u,a=[e[0]],l=a[0];for(t=1,n=e.length;n>t;t++)u=e[t],r=u.originalStart-(l.originalStart+l.originalLength),i=u.modifiedStart-(l.modifiedStart+l.modifiedLength),o=Math.min(r,i),s>o?(l.originalLength=u.originalStart+u.originalLength-l.originalStart,l.modifiedLength=u.modifiedStart+u.modifiedLength-l.modifiedStart):(a.push(u),l=u);return a}var u=5e3,s=3,a=function(){function e(e,t,n){this.buffer=e,this.startMarkers=t,this.endMarkers=n}return e.prototype.equals=function(t){if(!(t instanceof e))return!1;var n=t;if(this.getLength()!==n.getLength())return!1;for(var r=0,i=this.getLength();i>r;r++){var o=this.getElementHash(r),u=n.getElementHash(r);if(o!==u)return!1}return!0},e.prototype.getLength=function(){return this.startMarkers.length},e.prototype.getElementHash=function(e){return this.buffer.substring(this.startMarkers[e].offset,this.endMarkers[e].offset)},e.prototype.getStartLineNumber=function(e){return e===this.startMarkers.length?this.startMarkers[e-1].lineNumber+1:this.startMarkers[e].lineNumber},e.prototype.getStartColumn=function(e){return this.startMarkers[e].column},e.prototype.getEndLineNumber=function(e){return this.endMarkers[e].lineNumber},e.prototype.getEndColumn=function(e){return this.endMarkers[e].column},e}(),l=function(e){function t(n,r){var i,o,u,s,a,l="",h=[],m=[];for(u=0,i=0,o=n.length;o>i;i++)l+=n[i],s=1,a=n[i].length+1,r&&(s=t._getFirstNonBlankColumn(n[i],1),a=t._getLastNonBlankColumn(n[i],1)),h.push({offset:u+s-1,lineNumber:i+1,column:s}),m.push({offset:u+a-1,lineNumber:i+1,column:a}),u+=n[i].length;e.call(this,l,h,m)}return __extends(t,e),t._getFirstNonBlankColumn=function(e,t){var n=r.firstNonWhitespaceIndex(e);return-1===n?t:n+1},t._getLastNonBlankColumn=function(e,t){var n=r.lastNonWhitespaceIndex(e);return-1===n?t:n+2},t.prototype.getCharSequence=function(e,t){var n,r,i,o,u=[],s=[];for(n=e;t>=n;n++)for(i=this.startMarkers[n],o=this.endMarkers[n],r=i.offset;r<o.offset;r++)u.push({offset:r,lineNumber:i.lineNumber,column:i.column+(r-i.offset)}),s.push({offset:r+1,lineNumber:i.lineNumber,column:i.column+(r-i.offset)+1});return new a(this.buffer,u,s)},t}(a),h=function(){function e(e,t,n){0===e.originalLength?(this.originalStartLineNumber=0,this.originalStartColumn=0,this.originalEndLineNumber=0,this.originalEndColumn=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalStartColumn=t.getStartColumn(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1),this.originalEndColumn=t.getEndColumn(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=0,this.modifiedStartColumn=0,this.modifiedEndLineNumber=0,this.modifiedEndColumn=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedStartColumn=n.getStartColumn(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1),this.modifiedEndColumn=n.getEndColumn(e.modifiedStart+e.modifiedLength-1))}return e}(),m=function(){function e(e,t,n,r,u){if(0===e.originalLength?(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart)-1,this.originalEndLineNumber=0):(this.originalStartLineNumber=t.getStartLineNumber(e.originalStart),this.originalEndLineNumber=t.getEndLineNumber(e.originalStart+e.originalLength-1)),0===e.modifiedLength?(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart)-1,this.modifiedEndLineNumber=0):(this.modifiedStartLineNumber=n.getStartLineNumber(e.modifiedStart),this.modifiedEndLineNumber=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1)),0!==e.originalLength&&0!==e.modifiedLength&&r()){var s=t.getCharSequence(e.originalStart,e.originalStart+e.originalLength-1),a=n.getCharSequence(e.modifiedStart,e.modifiedStart+e.modifiedLength-1),l=i(s,a,r);u&&(l=o(l)),this.charChanges=[];for(var m=0,f=l.length;f>m;m++)this.charChanges.push(new h(l[m],s,a))}}return e}(),f=function(){function e(e,t,n){this.shouldPostProcessCharChanges=n.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=n.shouldIgnoreTrimWhitespace,this.maximumRunTimeMs=u,this.original=new l(e,this.shouldIgnoreTrimWhitespace),this.modified=new l(t,this.shouldIgnoreTrimWhitespace),n.shouldConsiderTrimWhitespaceInEmptyCase&&this.shouldIgnoreTrimWhitespace&&this.original.equals(this.modified)&&(this.shouldIgnoreTrimWhitespace=!1,this.original=new l(e,this.shouldIgnoreTrimWhitespace),this.modified=new l(t,this.shouldIgnoreTrimWhitespace))}return e.prototype.computeDiff=function(){this.computationStartTime=(new Date).getTime();for(var e=i(this.original,this.modified,this._continueProcessingPredicate.bind(this)),t=[],n=0,r=e.length;r>n;n++)t.push(new m(e[n],this.original,this.modified,this._continueProcessingPredicate.bind(this),this.shouldPostProcessCharChanges));return t},e.prototype._continueProcessingPredicate=function(){if(0===this.maximumRunTimeMs)return!0;var e=(new Date).getTime();return e-this.computationStartTime<this.maximumRunTimeMs},e}();t.DiffComputer=f}),define("vs/editor/common/modes/linkComputer",["require","exports"],function(e,t){"use strict";function n(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?g.computeLinks(e):[]}var r=[],i=1,o=9,u=10;r[1]={h:2,H:2},r[2]={t:3,T:3},r[3]={t:4,T:4},r[4]={p:5,P:5},r[5]={s:6,S:6,":":7},r[6]={":":7},r[7]={"/":8},r[8]={"/":9};var s;!function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"}(s||(s={}));var a=function(){var e=" 	<>'\"",t=".,;",n=null,r=function(e){for(var t=0,n=0,r=e.length;r>n;n++)t=Math.max(t,e.charCodeAt(n));return t},i=function(e,t){for(var r=0,i=e.length;i>r;r++)n[e.charCodeAt(r)]=t};return function(){if(null===n){var o=Math.max(r(e),r(t));n=[];for(var u=0;o>u;u++)n[u]=s.None;i(e,s.ForceTermination),i(t,s.CannotEndIn)}return n}}(),l="(".charCodeAt(0),h=")".charCodeAt(0),m="[".charCodeAt(0),f="]".charCodeAt(0),d="{".charCodeAt(0),c="}".charCodeAt(0),g=function(){function e(){}return e._createLink=function(e,t,n,r){return{range:{startLineNumber:t,startColumn:n+1,endLineNumber:t,endColumn:r+1},url:e.substring(n,r)}},e.computeLinks=function(t){var n,g,p,v,b,C,_,y,L,N,S,x,w,E,A,M=[],I=a(),R=I.length;for(n=1,g=t.getLineCount();g>=n;n++){for(p=t.getLineContent(n),v=0,C=p.length,_=0,y=i,w=!1,E=!1,A=!1;C>v;){if(L=p.charAt(v),N=p.charCodeAt(v),x=!1,y===u){switch(N){case l:w=!0,S=s.None;break;case h:S=w?s.None:s.ForceTermination;break;case m:E=!0,S=s.None;break;case f:S=E?s.None:s.ForceTermination;break;case d:A=!0,S=s.None;break;case c:S=A?s.None:s.ForceTermination;break;default:S=R>N?I[N]:s.None}if(S===s.ForceTermination){b=v-1;do{if(N=p.charCodeAt(b),S=R>N?I[N]:s.None,S!==s.CannotEndIn)break;b--}while(b>_);M.push(e._createLink(p,n,_,b+1)),x=!0}}else y===o?(S=R>N?I[N]:s.None,S===s.ForceTermination?x=!0:y=u):r[y].hasOwnProperty(L)?y=r[y][L]:x=!0;x&&(y=i,w=!1,E=!1,A=!1,_=v+1),v++}y===u&&M.push(e._createLink(p,n,_,C))}return M},e}();t.computeLinks=n}),define("vs/editor/common/modes/supports/inplaceReplaceSupport",["require","exports"],function(e,t){"use strict";var n=function(){function e(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}return e.prototype.navigateValueSet=function(e,t,n,r,i){if(e&&t){var o=this.doNavigateValueSet(t,i);if(o)return{range:e,value:o}}if(n&&r){var o=this.doNavigateValueSet(r,i);if(o)return{range:n,value:o}}return null},e.prototype.doNavigateValueSet=function(e,t){var n=this.numberReplace(e,t);return null!==n?n:this.textReplace(e,t)},e.prototype.numberReplace=function(e,t){var n=Math.pow(10,e.length-(e.lastIndexOf(".")+1)),r=Number(e),i=parseFloat(e);return isNaN(r)||isNaN(i)||r!==i?null:0!==r||t?(r=Math.floor(r*n),r+=t?n:-n,String(r/n)):null},e.prototype.textReplace=function(e,t){return this.valueSetsReplace(this._defaultValueSet,e,t)},e.prototype.valueSetsReplace=function(e,t,n){for(var r=null,i=0,o=e.length;null===r&&o>i;i++)r=this.valueSetReplace(e[i],t,n);return r},e.prototype.valueSetReplace=function(e,t,n){var r=e.indexOf(t);return r>=0?(r+=n?1:-1,0>r?r=e.length-1:r%=e.length,e[r]):null},e.INSTANCE=new e,e}();t.BasicInplaceReplace=n}),define("vs/editor/common/services/editorSimpleWorkerCommon",["require","exports"],function(e,t){"use strict";var n=function(){function e(){}return e.prototype.acceptNewModel=function(e){throw new Error("Not implemented!")},e.prototype.acceptModelChanged=function(e,t){throw new Error("Not implemented!")},e.prototype.acceptRemovedModel=function(e){throw new Error("Not implemented!")},e.prototype.computeDiff=function(e,t,n){throw new Error("Not implemented!")},e.prototype.computeDirtyDiff=function(e,t,n){throw new Error("Not implemented!")},e.prototype.computeLinks=function(e){throw new Error("Not implemented!")},e.prototype.textualSuggest=function(e,t,n,r){
throw new Error("Not implemented!")},e.prototype.navigateValueSet=function(e,t,n,r,i){throw new Error("Not implemented!")},e}();t.EditorSimpleWorker=n}),define("vs/editor/common/viewModel/prefixSumComputer",["require","exports"],function(e,t){"use strict";var n=function(){function e(e,t){this.index=e,this.remainder=t}return e}();t.PrefixSumIndexOfResult=n;var r=function(){function e(e){this.values=e,this.prefixSum=[];for(var t=0,n=this.values.length;n>t;t++)this.prefixSum[t]=0;this.prefixSumValidIndex=-1}return e.prototype.getCount=function(){return this.values.length},e.prototype.insertValue=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values.splice(e,0,t),this.prefixSum.splice(e,0,0),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.insertValues=function(t,n){t=Math.floor(t),0!==n.length&&(this.values=this.values.slice(0,t).concat(n).concat(this.values.slice(t)),this.prefixSum=this.prefixSum.slice(0,t).concat(e._zeroArray(n.length)).concat(this.prefixSum.slice(t)),t-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=t-1))},e._zeroArray=function(e){e=Math.floor(e);for(var t=[],n=0;e>n;n++)t[n]=0;return t},e.prototype.changeValue=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values[e]!==t&&(this.values[e]=t,e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1))},e.prototype.removeValues=function(e,t){e=Math.floor(e),t=Math.floor(t),this.values.splice(e,t),this.prefixSum.splice(e,t),e-1<this.prefixSumValidIndex&&(this.prefixSumValidIndex=e-1)},e.prototype.getTotalValue=function(){return 0===this.values.length?0:this.getAccumulatedValue(this.values.length-1)},e.prototype.getAccumulatedValue=function(e){if(e=Math.floor(e),0>e)return 0;if(e<=this.prefixSumValidIndex)return this.prefixSum[e];var t=this.prefixSumValidIndex+1;0===t&&(this.prefixSum[0]=this.values[0],t++),e>=this.values.length&&(e=this.values.length-1);for(var n=t;e>=n;n++)this.prefixSum[n]=this.prefixSum[n-1]+this.values[n];return this.prefixSumValidIndex=Math.max(this.prefixSumValidIndex,e),this.prefixSum[e]},e.prototype.getIndexOf=function(e){e=Math.floor(e);for(var t,r,i,o=0,u=this.values.length-1;u>=o;)if(t=o+(u-o)/2|0,r=this.getAccumulatedValue(t),i=r-this.values[t],i>e)u=t-1;else{if(!(e>=r))break;o=t+1}return new n(t,e-i)},e}();t.PrefixSumComputer=r}),define("vs/editor/common/model/mirrorModel2",["require","exports","vs/editor/common/viewModel/prefixSumComputer"],function(e,t,n){"use strict";var r=function(){function e(e,t,n,r){this._uri=e,this._lines=t,this._eol=n,this._versionId=r}return e.prototype.dispose=function(){this._lines.length=0},Object.defineProperty(e.prototype,"version",{get:function(){return this._versionId},enumerable:!0,configurable:!0}),e.prototype.getText=function(){return this._lines.join(this._eol)},e.prototype.onEvents=function(e){for(var t=null,n=0,r=e.length;r>n;n++){var i=e[n];i.eol&&(t=i.eol)}t&&t!==this._eol&&(this._eol=t,this._lineStarts=null);for(var o=-1,n=0,r=e.length;r>n;n++){var i=e[n];this._acceptDeleteRange(i.range),this._acceptInsertText({lineNumber:i.range.startLineNumber,column:i.range.startColumn},i.text),o=Math.max(o,i.versionId)}-1!==o&&(this._versionId=o)},e.prototype._ensureLineStarts=function(){if(!this._lineStarts){for(var e=[],t=this._eol.length,r=0,i=this._lines.length;i>r;r++)e.push(this._lines[r].length+t);this._lineStarts=new n.PrefixSumComputer(e)}},e.prototype._setLineText=function(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)},e.prototype._acceptDeleteRange=function(e){if(e.startLineNumber===e.endLineNumber){if(e.startColumn===e.endColumn)return;return void this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber)},e.prototype._acceptInsertText=function(e,t){if(0!==t.length){var n=t.split(/\r\n|\r|\n/);if(1===n.length)return void this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]+this._lines[e.lineNumber-1].substring(e.column-1));n[n.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+n[0]);for(var r=new Array(n.length-1),i=1;i<n.length;i++)this._lines.splice(e.lineNumber+i-1,0,n[i]),r[i-1]=n[i].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,r)}},e}();t.MirrorModel2=r}),define("vs/nls!vs/editor/common/config/defaultConfig",["vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker"],function(e,t){return e.create("vs/editor/common/config/defaultConfig",t)}),define("vs/editor/common/config/defaultConfig",["require","exports","vs/nls!vs/editor/common/config/defaultConfig"],function(e,t,n){"use strict";t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",t.DEFAULT_INDENTATION={tabSize:4,insertSpaces:!0,detectIndentation:!0};var r=function(){function e(){this.editor={experimentalScreenReader:!0,rulers:[],wordSeparators:t.USUAL_WORD_SEPARATORS,selectionClipboard:!0,ariaLabel:n.localize(0,null),lineNumbers:!0,selectOnLineNumbers:!0,lineNumbersMinChars:5,glyphMargin:!1,lineDecorationsWidth:10,revealHorizontalRightPadding:30,roundedSelection:!0,theme:"vs",readOnly:!1,scrollbar:{verticalScrollbarSize:14,horizontal:"auto",useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1},overviewRulerLanes:2,cursorBlinking:"blink",cursorStyle:"line",fontLigatures:!1,hideCursorInOverviewRuler:!1,scrollBeyondLastLine:!0,automaticLayout:!1,wrappingColumn:300,wrappingIndent:"same",wordWrapBreakBeforeCharacters:"([{‘“〈《「『【〔（［｛｢£¥＄￡￥+＋",wordWrapBreakAfterCharacters:" 	})]?|&,;¢°′″‰℃、。｡､￠，．：；？！％・･ゝゞヽヾーァィゥェォッャュョヮヵヶぁぃぅぇぉっゃゅょゎゕゖㇰㇱㇲㇳㇴㇵㇶㇷㇸㇹㇺㇻㇼㇽㇾㇿ々〻ｧｨｩｪｫｬｭｮｯｰ’”〉》」』】〕）］｝｣",wordWrapBreakObtrusiveCharacters:".",tabFocusMode:!1,longLineBoundary:300,forcedTokenizationBoundary:1e3,hover:!0,contextmenu:!0,mouseWheelScrollSensitivity:1,quickSuggestions:!0,quickSuggestionsDelay:10,iconsInSuggestions:!0,autoClosingBrackets:!0,formatOnType:!1,suggestOnTriggerCharacters:!0,acceptSuggestionOnEnter:!0,selectionHighlight:!0,outlineMarkers:!1,referenceInfos:!0,folding:!0,renderWhitespace:!1,indentGuides:!1,fontFamily:"",fontSize:0,lineHeight:0}}return e}();t.DefaultConfig=new r}),define("vs/editor/common/modes/nullMode",["require","exports","vs/editor/common/config/defaultConfig"],function(e,t,n){"use strict";function r(e,t,n,r,i){void 0===r&&(r=0);var o=[{startIndex:r,type:""}],u=[{startIndex:r,mode:e}];return{tokens:o,actualStopOffset:r+t.length,endState:n,modeTransitions:u}}var i=function(){function e(e,t){this.mode=e,this.stateData=t}return e.prototype.clone=function(){var t=this.stateData?this.stateData.clone():null;return new e(this.mode,t)},e.prototype.equals=function(e){if(this.mode!==e.getMode())return!1;var t=e.getStateData();return this.stateData||t?this.stateData&&t?this.stateData.equals(t):!1:!0},e.prototype.getMode=function(){return this.mode},e.prototype.tokenize=function(e){return e.advanceToEOS(),{type:""}},e.prototype.getStateData=function(){return this.stateData},e.prototype.setStateData=function(e){this.stateData=e},e}();t.NullState=i;var o=function(){function e(){this.richEditSupport={wordDefinition:e.DEFAULT_WORD_REGEXP}}return e.createWordRegExp=function(e){void 0===e&&(e="");for(var t=n.USUAL_WORD_SEPARATORS,r="(-?\\d*\\.\\d\\w*)|([^",i=0;i<t.length;i++)e.indexOf(t[i])>=0||(r+="\\"+t[i]);return r+="\\s]+)",new RegExp(r,"g")},e.prototype.getId=function(){return e.ID},e.prototype.toSimplifiedMode=function(){return this},e.DEFAULT_WORD_REGEXP=e.createWordRegExp(),e.ID="vs.editor.modes.nullMode",e}();t.NullMode=o,t.nullTokenize=r}),define("vs/editor/common/model/textModelWithTokensHelpers",["require","exports","vs/editor/common/modes/nullMode","vs/editor/common/core/modeTransition"],function(e,t,n,r){"use strict";var i=function(){function e(){}return e._safeGetWordDefinition=function(e){return e.richEditSupport?e.richEditSupport.wordDefinition:null},e.ensureValidWordDefinition=function(e){var t=n.NullMode.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)t=e;else{var r="g";e.ignoreCase&&(r+="i"),e.multiline&&(r+="m"),t=new RegExp(e.source,r)}return t.lastIndex=0,t},e.massageWordDefinitionOf=function(t){return e.ensureValidWordDefinition(e._safeGetWordDefinition(t))},e.getWords=function(t,n){if(!t._lineIsTokenized(n))return e._getWordsInText(t.getLineContent(n),e.massageWordDefinitionOf(t.getMode()));var r=[],i=t.getLineContent(n);if(i.length>0){var o,u,s,a,l,h,m,f,d,c,g,p,v=t._getLineModeTransitions(n);for(o=0,l=0,u=v.length;u>o;o++)if(m=e.massageWordDefinitionOf(v[o].mode),l=v[o].startIndex,h=u>o+1?v[o+1].startIndex:i.length,f=i.substring(l,h),d=f.match(m))for(g=0,s=0,a=d.length;a>s;s++)p=d[s],p.length>0&&(c=f.indexOf(p,g),g=c+p.length,r.push({start:l+c,end:l+g}))}return r},e._getWordsInText=function(e,t){var n,r,i,o,u,s,a=e.match(t)||[],l=[];for(n=0;n<a.length;n++)s=a[n].trim(),s.length>0&&(r=e.indexOf(s,i),i=r+s.length,o=r,u=i,l.push({start:o,end:u}));return l},e._getWordAtColumn=function(t,n,r,i){var o=i[r].startIndex,u=r+1<i.length?i[r+1].startIndex:t.length,s=i[r].mode;return e._getWordAtText(n,e.massageWordDefinitionOf(s),t.substring(o,u),o)},e.getWordAtPosition=function(t,n){if(!t._lineIsTokenized(n.lineNumber))return e._getWordAtText(n.column,e.massageWordDefinitionOf(t.getMode()),t.getLineContent(n.lineNumber),0);var i=null,o=t.getLineContent(n.lineNumber),u=t._getLineModeTransitions(n.lineNumber),s=n.column-1,a=r.ModeTransition.findIndexInSegmentsArray(u,s);return i=e._getWordAtColumn(o,n.column,a,u),!i&&a>0&&u[a].startIndex===s&&(i=e._getWordAtColumn(o,n.column,a-1,u)),i},e._getWordAtText=function(e,t,n,r){var i,o,u,s,a,l,h=n.match(t);if(h)for(i=0;i<h.length;i++)if(l=h[i].trim(),l.length>0&&(o=n.indexOf(l,u),u=o+l.length,s=r+o+1,a=r+u+1,e>=s&&a>=e))return{word:l,startColumn:s,endColumn:a};return null},e}();t.WordHelper=i});var __extends=this&&this.__extends||function(e,t){function n(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)};define("vs/editor/common/services/editorSimpleWorker",["require","exports","vs/base/common/uri","vs/base/common/winjs.base","vs/editor/common/core/range","vs/base/common/filters","vs/editor/common/diff/diffComputer","vs/editor/common/model/mirrorModel2","vs/editor/common/model/textModelWithTokensHelpers","vs/editor/common/modes/linkComputer","vs/editor/common/modes/supports/inplaceReplaceSupport","vs/editor/common/services/editorSimpleWorkerCommon"],function(e,t,n,r,i,o,u,s,a,l,h,m){"use strict";function f(){return new c}var d=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.getLinesContent=function(){return this._lines.slice(0)},t.prototype.getLineCount=function(){return this._lines.length},t.prototype.getLineContent=function(e){return this._lines[e-1]},t.prototype.getWordAtPosition=function(e,t){var n=a.WordHelper._getWordAtText(e.column,a.WordHelper.ensureValidWordDefinition(t),this._lines[e.lineNumber-1],0);return n?new i.Range(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn):null},t.prototype.getWordUntilPosition=function(e,t){var n=this.getWordAtPosition(e,t);return n?{word:this._lines[e.lineNumber-1].substring(n.startColumn-1,e.column-1),startColumn:n.startColumn,endColumn:e.column}:{word:"",startColumn:e.column,endColumn:e.column}},t.prototype._getAllWords=function(e){var t=this,n=[];return this._lines.forEach(function(r){t._wordenize(r,e).forEach(function(e){n.push(r.substring(e.start,e.end))})}),n},t.prototype.getAllUniqueWords=function(e,t){var n=!1,r={};return this._getAllWords(e).filter(function(e){return t&&!n&&t===e?(n=!0,!1):r[e]?!1:(r[e]=!0,!0)})},t.prototype._wordenize=function(e,t){for(var n,r=[];(n=t.exec(e))&&0!==n[0].length;)r.push({start:n.index,end:n.index+n[0].length});return r},t.prototype.getValueInRange=function(e){if(e.startLineNumber===e.endLineNumber)return this._lines[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);var t=this._eol,n=e.startLineNumber-1,r=e.endLineNumber-1,i=[];i.push(this._lines[n].substring(e.startColumn-1));for(var o=n+1;r>o;o++)i.push(this._lines[o]);return i.push(this._lines[r].substring(0,e.endColumn-1)),i.join(t)},t}(s.MirrorModel2),c=function(e){function t(){e.call(this),this._models=Object.create(null)}return __extends(t,e),t.prototype.acceptNewModel=function(e){this._models[e.url]=new d(n["default"].parse(e.url),e.value.lines,e.value.EOL,e.versionId)},t.prototype.acceptModelChanged=function(e,t){if(this._models[e]){var n=this._models[e];n.onEvents(t)}},t.prototype.acceptRemovedModel=function(e){this._models[e]&&delete this._models[e]},t.prototype.computeDiff=function(e,t,n){var i=this._models[e],o=this._models[t];if(!i||!o)return null;var s=i.getLinesContent(),a=o.getLinesContent(),l=new u.DiffComputer(s,a,{shouldPostProcessCharChanges:!0,shouldIgnoreTrimWhitespace:n,shouldConsiderTrimWhitespaceInEmptyCase:!0});return r.TPromise.as(l.computeDiff())},t.prototype.computeDirtyDiff=function(e,t,n){var i=this._models[e],o=this._models[t];if(!i||!o)return null;var s=i.getLinesContent(),a=o.getLinesContent(),l=new u.DiffComputer(s,a,{shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:n,shouldConsiderTrimWhitespaceInEmptyCase:!1});return r.TPromise.as(l.computeDiff())},t.prototype.computeLinks=function(e){var t=this._models[e];return t?r.TPromise.as(l.computeLinks(t)):null},t.prototype.textualSuggest=function(e,t,n,i){var o=this._models[e];return o?r.TPromise.as(this._suggestFiltered(o,t,new RegExp(n,i))):null},t.prototype._suggestFiltered=function(e,t,n){var r=this._suggestUnfiltered(e,t,n);return[{currentWord:r.currentWord,suggestions:r.suggestions.filter(function(e){return!!o.fuzzyContiguousFilter(r.currentWord,e.label)}),incomplete:r.incomplete}]},t.prototype._suggestUnfiltered=function(e,t,n){var r=e.getWordUntilPosition(t,n).word,i=e.getAllUniqueWords(n,r),o=i.filter(function(e){return!/^-?\d*\.?\d/.test(e)}).map(function(e){return{type:"text",label:e,codeSnippet:e,noAutoAccept:!0}});return{currentWord:r,suggestions:o}},t.prototype.navigateValueSet=function(e,t,n,i,o){var u=this._models[e];if(!u)return null;var s=new RegExp(i,o);t.startColumn===t.endColumn&&(t.endColumn+=1);var a=u.getValueInRange(t),l=u.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},s),m=null;null!==l&&(m=u.getValueInRange(l));var f=h.BasicInplaceReplace.INSTANCE.navigateValueSet(t,a,l,m,n);return r.TPromise.as(f)},t}(m.EditorSimpleWorker);t.EditorSimpleWorkerImpl=c,t.create=f});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c212f0908f3d29933317bbc3233568fbca7944b1/vs/editor/common/services/editorSimpleWorker.js.map
