/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/languages/css/common/cssTokenTypes",["require","exports"],function(t,e){"use strict";e.TOKEN_SELECTOR="entity.name.selector",e.TOKEN_SELECTOR_TAG="entity.name.tag",e.TOKEN_PROPERTY="support.type.property-name",e.TOKEN_VALUE="support.property-value",e.TOKEN_AT_KEYWORD="keyword.control.at-rule"});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,r){var o,i=arguments.length,s=3>i?e:null===r?r=Object.getOwnPropertyDescriptor(e,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(t,e,n,r);else for(var c=t.length-1;c>=0;c--)(o=t[c])&&(s=(3>i?o(s):i>3?o(e,n,s):o(e,n))||s);return i>3&&s&&Object.defineProperty(e,n,s),s},__param=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define("vs/languages/css/common/css",["require","exports","vs/base/common/objects","vs/platform/thread/common/threadService","vs/languages/css/common/cssTokenTypes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/editor/common/modes/supports/richEditSupport","vs/editor/common/modes/supports/tokenizationSupport","vs/editor/common/modes/supports/declarationSupport","vs/editor/common/modes/supports/referenceSupport","vs/editor/common/modes/supports/suggestSupport"],function(t,e,n,r,o,i,s,c,a,u,p,f,h,l){"use strict";e.cssTokenTypes=o,function(t){t[t.Selector=0]="Selector",t[t.Rule=1]="Rule",t[t.Value=2]="Value",t[t.ValuePostUrl=3]="ValuePostUrl",t[t.ValueInUrlFunction=4]="ValueInUrlFunction",t[t.Unit=5]="Unit",t[t.Meta=6]="Meta",t[t.MetaPostUrl=7]="MetaPostUrl",t[t.MetaInUrlFunction=8]="MetaInUrlFunction"}(e.States||(e.States={}));var d=e.States,k=/^-?-?([a-zA-Z]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))([\w\-]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))*/,g=function(t){function e(e,n,r,o,i,s){t.call(this,e),this.kind=n,this.inComment=r,this.quote=o,this.inMeta=i,this.metaBraceCount=s}return __extends(e,t),e.prototype.nextState=function(t,e){return this.kind=t,e},e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.inComment,this.quote,this.inMeta,this.metaBraceCount)},e.prototype.equals=function(e){return t.prototype.equals.call(this,e)&&n.equals(this,e)},e.prototype.tokenizeInComment=function(t){return/\*\/$/.test(t.advanceUntilString("*/",!0))&&(this.inComment=!1),{type:"comment.css"}},e.prototype.tokenizeInString=function(t){for(var e,n=!1,r=this.quote;!t.eos();)if(e=t.next(),n)n=!1;else if("\\"===e)n=!0;else if(e===r){this.quote=null;break}return{type:"string.css"}},e.prototype.consumeIdent=function(t){return t.goBack(1),t.advanceIfRegExp2(k)?!0:(t.advance(1),!1)},e.prototype.tokenize=function(t){if(this.inComment)return this.tokenizeInComment(t);if(null!==this.quote)return this.tokenizeInString(t);if(t.skipWhitespace2())return{type:""};if(t.advanceIfString2("/*"))return this.inComment=!0,this.tokenizeInComment(t);if(t.advanceIfString2("'"))return this.quote="'",this.tokenizeInString(t);if(t.advanceIfString2('"'))return this.quote='"',this.tokenizeInString(t);var e=t.next();switch(this.kind){case d.ValuePostUrl:if("("===e)return this.nextState(d.ValueInUrlFunction,{type:"punctuation.parenthesis.css"});this.kind=d.Value;break;case d.MetaPostUrl:if("("===e)return this.nextState(d.MetaInUrlFunction,{type:"punctuation.parenthesis.css"});this.kind=d.Meta;break;case d.ValueInUrlFunction:case d.MetaInUrlFunction:if(")"!==e)return t.advanceIfRegExp2(/^[^\)]*/),{type:"string.css"};this.kind=this.kind===d.ValueInUrlFunction?d.Value:d.Meta}switch(this.kind){case d.Selector:return"{"===e?this.nextState(d.Rule,{type:"punctuation.bracket.css"}):"("===e||")"===e?{type:"punctuation.parenthesis.css"}:"@"!==e||this.inMeta?"}"===e&&this.inMeta?(this.inMeta=!1,this.nextState(d.Selector,{type:"punctuation.bracket.css"})):/[\*\(\)\[\]\+>=\~\|;]/.test(e)?{type:"punctuation.css"}:"#"===e?(t.advanceIfRegExp2(k),{type:o.TOKEN_SELECTOR+".id.css"}):"."===e?(t.advanceIfRegExp2(k),{type:o.TOKEN_SELECTOR+".class.css"}):(this.consumeIdent(t),{type:o.TOKEN_SELECTOR_TAG+".css"}):(t.advanceIfRegExp2(k),this.nextState(d.Meta,{type:o.TOKEN_AT_KEYWORD+".css"}));case d.Meta:if("{"===e){var n=d.Rule;return this.inMeta&&(n=d.Selector),this.nextState(n,{type:"punctuation.bracket.css"})}return"("===e||")"===e?{type:"punctuation.parenthesis.css"}:";"===e?(0===this.metaBraceCount&&(this.inMeta=!1),this.nextState(d.Selector,{type:"punctuation.css"})):"u"!==e&&"U"!==e||!t.advanceIfStringCaseInsensitive2("rl")?/[\*\(\)\[\]\+>=\~\|]/.test(e)?{type:"punctuation.css"}:(this.inMeta=!0,this.consumeIdent(t),{type:o.TOKEN_VALUE+".css"}):(t.advanceIfStringCaseInsensitive2("-prefix"),this.nextState(d.MetaPostUrl,{type:o.TOKEN_VALUE+".css"}));case d.Rule:return"}"===e?this.nextState(d.Selector,{type:"punctuation.bracket.css"}):":"===e?this.nextState(d.Value,{type:"punctuation.css"}):"("===e||")"===e?{type:"punctuation.parenthesis.css"}:(this.consumeIdent(t),{type:o.TOKEN_PROPERTY+".css"});case d.Value:if("}"===e)return this.nextState(d.Selector,{type:"punctuation.bracket.css"});if(";"===e)return this.nextState(d.Rule,{type:"punctuation.css"});if(("u"===e||"U"===e)&&t.advanceIfStringCaseInsensitive2("rl"))return this.nextState(d.ValuePostUrl,{type:o.TOKEN_VALUE+".css"});if("("===e||")"===e)return{type:"punctuation.parenthesis.css"};if(","===e)return{type:"punctuation.css"};if("#"===e)return t.advanceIfRegExp2(/^[\w]*/),{type:o.TOKEN_VALUE+".hex.css"};if(/\d/.test(e)||/-|\+/.test(e)&&!t.eos()&&/\d/.test(t.peek()))return t.advanceIfRegExp2(/^[\d\.]*/),this.nextState(d.Unit,{type:o.TOKEN_VALUE+".numeric.css"});if("!"===e)return{type:o.TOKEN_VALUE+".keyword.css"};if(("i"===e||"I"===e)&&t.advanceIfStringCaseInsensitive2("mportant"))return{type:o.TOKEN_VALUE+".keyword.css"};if(this.consumeIdent(t))return{type:o.TOKEN_VALUE+".css"};break;case d.Unit:return t.goBack(1),t.advanceIfRegExp2(/^(em|ex|ch|rem|vw|vh|vm|cm|mm|in|px|pt|pc|deg|grad|rad|turn|s|ms|Hz|kHz|%)/)?{type:o.TOKEN_VALUE+".unit.css"}:(this.nextState(d.Value,null),this.tokenize(t))}return{type:""}},e}(s.AbstractState);e.State=g;var m=function(t){function e(e,n,r){var s=this;t.call(this,e.id),this._modeWorkerManager=new i.ModeWorkerManager(e,"vs/languages/css/common/cssWorker","CSSWorker",null,n),this._threadService=r,this.tokenizationSupport=new p.TokenizationSupport(this,{getInitialState:function(){return new g(s,d.Selector,!1,null,!1,0)}},!1,!1),this.richEditSupport=new u.RichEditSupport(this.getId(),null,{wordPattern:/(#?-?\d*\.\d\w*%?)|((::|[@#.!:])?[\w-?]+%?)|::|[@#.!:]/g,comments:{blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],__characterPairSupport:{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string"]}]}}),this.inplaceReplaceSupport=this,this.configSupport=this,this.occurrencesSupport=this,this.extraInfoSupport=this,this.referenceSupport=new h.ReferenceSupport(this.getId(),{tokens:[o.TOKEN_PROPERTY+".css",o.TOKEN_VALUE+".css",o.TOKEN_SELECTOR_TAG+".css"],findReferences:function(t,e,n){return s.findReferences(t,e)}}),this.logicalSelectionSupport=this,this.outlineSupport=this,this.declarationSupport=new f.DeclarationSupport(this.getId(),{tokens:[o.TOKEN_VALUE+".css"],findDeclaration:function(t,e){return s.findDeclaration(t,e)}}),this.suggestSupport=new l.SuggestSupport(this.getId(),{triggerCharacters:[" ",":"],excludeTokens:["comment.css","string.css"],suggest:function(t,e){return s.suggest(t,e)}}),this.quickFixSupport=this}return __extends(e,t),e.prototype.creationDone=function(){this._threadService.isInMainThread&&this._pickAWorkerToValidate()},e.prototype._worker=function(t){return this._modeWorkerManager.worker(t)},e.prototype.configure=function(t){return this._threadService.isInMainThread?this._configureWorkers(t):this._worker(function(e){return e._doConfigure(t)})},e.prototype._configureWorkers=function(t){return this._worker(function(e){return e._doConfigure(t)})},e.prototype.navigateValueSet=function(t,e,n){return this._worker(function(r){return r.navigateValueSet(t,e,n)})},e.prototype._pickAWorkerToValidate=function(){return this._worker(function(t){return t.enableValidator()})},e.prototype.findOccurrences=function(t,e,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(t,e,n)})},e.prototype.suggest=function(t,e){return this._worker(function(n){return n.suggest(t,e)})},e.prototype.findDeclaration=function(t,e){return this._worker(function(n){return n.findDeclaration(t,e)})},e.prototype.computeInfo=function(t,e){return this._worker(function(n){return n.computeInfo(t,e)})},e.prototype.findReferences=function(t,e){return this._worker(function(n){return n.findReferences(t,e)})},e.prototype.getRangesToPosition=function(t,e){return this._worker(function(n){return n.getRangesToPosition(t,e)})},e.prototype.getOutline=function(t){return this._worker(function(e){return e.getOutline(t)})},e.prototype.findColorDeclarations=function(t){return this._worker(function(e){return e.findColorDeclarations(t)})},e.prototype.getQuickFixes=function(t,e){return this._worker(function(n){return n.getQuickFixes(t,e)})},e.prototype.runQuickFixAction=function(t,e,n){return this._worker(function(r){return r.runQuickFixAction(t,e,n)})},e.$_configureWorkers=r.AllWorkersAttr(e,e.prototype._configureWorkers),e.$navigateValueSet=r.OneWorkerAttr(e,e.prototype.navigateValueSet),e.$_pickAWorkerToValidate=r.OneWorkerAttr(e,e.prototype._pickAWorkerToValidate,a.ThreadAffinity.Group1),e.$findOccurrences=r.OneWorkerAttr(e,e.prototype.findOccurrences),e.$suggest=r.OneWorkerAttr(e,e.prototype.suggest),e.$findDeclaration=r.OneWorkerAttr(e,e.prototype.findDeclaration),e.$computeInfo=r.OneWorkerAttr(e,e.prototype.computeInfo),e.$findReferences=r.OneWorkerAttr(e,e.prototype.findReferences),e.$getRangesToPosition=r.OneWorkerAttr(e,e.prototype.getRangesToPosition),e.$getOutline=r.OneWorkerAttr(e,e.prototype.getOutline),e.$findColorDeclarations=r.OneWorkerAttr(e,e.prototype.findColorDeclarations),e.getQuickFixes=r.OneWorkerAttr(e,e.prototype.getQuickFixes),e.runQuickFixAction=r.OneWorkerAttr(e,e.prototype.runQuickFixAction),e=__decorate([__param(1,c.IInstantiationService),__param(2,a.IThreadService)],e)}(i.AbstractMode);e.CSSMode=m});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c212f0908f3d29933317bbc3233568fbca7944b1/vs/languages/css/common/css.js.map
