/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/languages/html/common/htmlEmptyTagsShared",["require","exports","vs/base/common/arrays"],function(t,e,n){"use strict";function r(t){return n.binarySearch(e.EMPTY_ELEMENTS,t,function(t,e){return t.localeCompare(e)})>=0}e.EMPTY_ELEMENTS=["area","base","br","col","embed","hr","img","input","keygen","link","menuitem","meta","param","source","track","wbr"],e.isEmptyElement=r}),define("vs/languages/html/common/htmlTokenTypes",["require","exports","vs/base/common/strings"],function(t,e,n){"use strict";function r(t){return n.startsWith(t,o)}function i(t){return o+t}e.DELIM_END="punctuation.definition.meta.tag.end.html",e.DELIM_START="punctuation.definition.meta.tag.begin.html",e.DELIM_ASSIGN="meta.tag.assign.html",e.ATTRIB_NAME="entity.other.attribute-name.html",e.ATTRIB_VALUE="string.html",e.COMMENT="comment.html.content",e.DELIM_COMMENT="comment.html",e.DOCTYPE="entity.other.attribute-name.html",e.DELIM_DOCTYPE="entity.name.tag.html";var o="entity.name.tag.tag-";e.isTag=r,e.getTag=i});var __extends=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},__decorate=this&&this.__decorate||function(t,e,n,r){var i,o=arguments.length,a=3>o?e:null===r?r=Object.getOwnPropertyDescriptor(e,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)a=Reflect.decorate(t,e,n,r);else for(var s=t.length-1;s>=0;s--)(i=t[s])&&(a=(3>o?i(a):o>3?i(e,n,a):i(e,n))||a);return o>3&&a&&Object.defineProperty(e,n,a),a},__param=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define("vs/languages/html/common/html",["require","exports","vs/base/common/winjs.base","vs/editor/common/modes","vs/editor/common/modes/abstractMode","vs/editor/common/modes/abstractState","vs/platform/thread/common/threadService","vs/editor/common/services/modeService","vs/platform/instantiation/common/instantiation","vs/languages/html/common/htmlTokenTypes","vs/languages/html/common/htmlEmptyTagsShared","vs/editor/common/modes/supports/richEditSupport","vs/editor/common/modes/supports/tokenizationSupport","vs/editor/common/modes/supports/referenceSupport","vs/editor/common/modes/supports/parameterHintsSupport","vs/editor/common/modes/supports/suggestSupport","vs/platform/thread/common/thread"],function(t,e,n,r,i,o,a,s,u,c,p,d,h,m,g,l,f){"use strict";e.htmlTokenTypes=c,e.EMPTY_ELEMENTS=p.EMPTY_ELEMENTS,function(t){t[t.Content=0]="Content",t[t.OpeningStartTag=1]="OpeningStartTag",t[t.OpeningEndTag=2]="OpeningEndTag",t[t.WithinDoctype=3]="WithinDoctype",t[t.WithinTag=4]="WithinTag",t[t.WithinComment=5]="WithinComment",t[t.WithinEmbeddedContent=6]="WithinEmbeddedContent",t[t.AttributeName=7]="AttributeName",t[t.AttributeValue=8]="AttributeValue"}(e.States||(e.States={}));var T=e.States,y=["script","style"],k=function(t){function e(e,n,r,i,o,a,s){t.call(this,e),this.kind=n,this.lastTagName=r,this.lastAttributeName=i,this.embeddedContentType=o,this.attributeValueQuote=a,this.attributeValue=s}return __extends(e,t),e.escapeTagName=function(t){return c.getTag(t.replace(/[:_.]/g,"-"))},e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.lastTagName,this.lastAttributeName,this.embeddedContentType,this.attributeValueQuote,this.attributeValue)},e.prototype.equals=function(n){return n instanceof e?t.prototype.equals.call(this,n)&&this.kind===n.kind&&this.lastTagName===n.lastTagName&&this.lastAttributeName===n.lastAttributeName&&this.embeddedContentType===n.embeddedContentType&&this.attributeValueQuote===n.attributeValueQuote&&this.attributeValue===n.attributeValue:!1},e.prototype.nextName=function(t){return t.advanceIfRegExp(/^[_:\w][_:\w-.\d]*/).toLowerCase()},e.prototype.tokenize=function(t){switch(this.kind){case T.WithinComment:if(t.advanceUntilString2("-->",!1))return{type:c.COMMENT};if(t.advanceIfString2("-->"))return this.kind=T.Content,{type:c.DELIM_COMMENT,dontMergeWithPrev:!0};break;case T.WithinDoctype:if(t.advanceUntilString2(">",!1))return{type:c.DOCTYPE};if(t.advanceIfString2(">"))return this.kind=T.Content,{type:c.DELIM_DOCTYPE,dontMergeWithPrev:!0};break;case T.Content:if(t.advanceIfCharCode2("<".charCodeAt(0))){if(!t.eos()&&"!"===t.peek()){if(t.advanceIfString2("!--"))return this.kind=T.WithinComment,{type:c.DELIM_COMMENT,dontMergeWithPrev:!0};if(t.advanceIfStringCaseInsensitive2("!DOCTYPE"))return this.kind=T.WithinDoctype,{type:c.DELIM_DOCTYPE,dontMergeWithPrev:!0}}return t.advanceIfCharCode2("/".charCodeAt(0))?(this.kind=T.OpeningEndTag,{type:c.DELIM_END,dontMergeWithPrev:!0}):(this.kind=T.OpeningStartTag,{type:c.DELIM_START,dontMergeWithPrev:!0})}break;case T.OpeningEndTag:var n=this.nextName(t);return n.length>0?{type:e.escapeTagName(n)}:t.advanceIfString2(">")?(this.kind=T.Content,{type:c.DELIM_END,dontMergeWithPrev:!0}):(t.advanceUntilString2(">",!1),{type:""});case T.OpeningStartTag:if(this.lastTagName=this.nextName(t),this.lastTagName.length>0)return this.lastAttributeName=null,"script"!==this.lastTagName&&"style"!==this.lastTagName||(this.lastAttributeName=null,this.embeddedContentType=null),this.kind=T.WithinTag,{type:e.escapeTagName(this.lastTagName)};break;case T.WithinTag:if(t.skipWhitespace2()||t.eos())return{type:""};var r=this.nextName(t);return r.length>0?(this.lastAttributeName=r,this.kind=T.AttributeName,{type:c.ATTRIB_NAME}):t.advanceIfString2("/>")?(this.kind=T.Content,{type:c.DELIM_START,dontMergeWithPrev:!0}):t.advanceIfCharCode2(">".charCodeAt(0))?-1!==y.indexOf(this.lastTagName)?(this.kind=T.WithinEmbeddedContent,{type:c.DELIM_START,dontMergeWithPrev:!0}):(this.kind=T.Content,{type:c.DELIM_START,dontMergeWithPrev:!0}):(t.next2(),{type:""});case T.AttributeName:return t.skipWhitespace2()||t.eos()?{type:""}:t.advanceIfCharCode2("=".charCodeAt(0))?(this.kind=T.AttributeValue,{type:c.DELIM_ASSIGN}):(this.kind=T.WithinTag,this.tokenize(t));case T.AttributeValue:if(t.eos())return{type:""};if(t.skipWhitespace2())return'"'===this.attributeValueQuote||"'"===this.attributeValueQuote?{type:c.ATTRIB_VALUE}:{type:""};if('"'!==this.attributeValueQuote&&"'"!==this.attributeValueQuote){var i=t.advanceIfRegExp(/^[^\s"'`=<>]+/);if(i.length>0)return this.kind=T.WithinTag,{type:c.ATTRIB_VALUE};var o=t.peek();return"'"===o||'"'===o?(this.attributeValueQuote=o,this.attributeValue=o,t.next2(),{type:c.ATTRIB_VALUE}):(this.kind=T.WithinTag,this.tokenize(t))}if(this.attributeValue!==this.attributeValueQuote||"script"!==this.lastTagName&&"style"!==this.lastTagName||"type"!==this.lastAttributeName){if(t.advanceIfCharCode2(this.attributeValueQuote.charCodeAt(0)))this.kind=T.WithinTag,this.attributeValue="",this.attributeValueQuote="";else{var a=t.next();this.attributeValue+=a}return{type:c.ATTRIB_VALUE}}if(this.attributeValue=t.advanceUntilString(this.attributeValueQuote,!0),this.attributeValue.length>0)return this.embeddedContentType=this.unquote(this.attributeValue),this.kind=T.WithinTag,this.attributeValue="",this.attributeValueQuote="",{type:c.ATTRIB_VALUE}}return t.next2(),this.kind=T.Content,{type:""}},e.prototype.unquote=function(t){var e=0,n=t.length;return'"'===t[0]&&e++,'"'===t[n-1]&&n--,t.substring(e,n)},e}(o.AbstractState);e.State=k;var b=function(t){function e(e,n,r,i){var o=this;t.call(this,e.id),this._modeWorkerManager=this._createModeWorkerManager(e,n),this.modeService=r,this.threadService=i,this.tokenizationSupport=new h.TokenizationSupport(this,this,!0,!0),this.linkSupport=this,this.configSupport=this,this.formattingSupport=this,this.extraInfoSupport=this,this.occurrencesSupport=this,this.referenceSupport=new m.ReferenceSupport(this.getId(),{tokens:["invalid"],findReferences:function(t,e,n){return o.findReferences(t,e,n)}}),this.logicalSelectionSupport=this,this.parameterHintsSupport=new g.ParameterHintsSupport(this.getId(),{triggerCharacters:["(",","],excludeTokens:["*"],getParameterHints:function(t,e){return o.getParameterHints(t,e)}}),this.suggestSupport=new l.SuggestSupport(this.getId(),{triggerCharacters:[".",":","<",'"',"=","/"],excludeTokens:["comment"],suggest:function(t,e){return o.suggest(t,e)}}),this.richEditSupport=this._createRichEditSupport()}return __extends(e,t),e.prototype.asyncCtor=function(){return n.Promise.join([this.modeService.getOrCreateMode("text/css"),this.modeService.getOrCreateMode("text/javascript")])},e.prototype._createModeWorkerManager=function(t,e){return new i.ModeWorkerManager(t,"vs/languages/html/common/htmlWorker","HTMLWorker",null,e)},e.prototype._worker=function(t){return this._modeWorkerManager.worker(t)},e.prototype._createRichEditSupport=function(){return new d.RichEditSupport(this.getId(),null,{wordPattern:i.createWordRegExp("#-?%"),comments:{blockComment:["<!--","-->"]},brackets:[["<!--","-->"],["<",">"]],__electricCharacterSupport:{caseInsensitive:!0,embeddedElectricCharacters:["*","}","]",")"]},__characterPairSupport:{autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"'},{open:"'",close:"'"}],surroundingPairs:[{open:'"',close:'"'},{open:"'",close:"'"}]},onEnterRules:[{beforeText:new RegExp("<(?!(?:"+p.EMPTY_ELEMENTS.join("|")+"))(\\w[\\w\\d]*)([^/>]*(?!/)>)[^<]*$","i"),afterText:/^<\/(\w[\w\d]*)\s*>$/i,action:{indentAction:r.IndentAction.IndentOutdent}},{beforeText:new RegExp("<(?!(?:"+p.EMPTY_ELEMENTS.join("|")+"))(\\w[\\w\\d]*)([^/>]*(?!/)>)[^<]*$","i"),action:{indentAction:r.IndentAction.Indent}}]})},e.prototype.getInitialState=function(){return new k(this,T.Content,"","","","","")},e.prototype.enterNestedMode=function(t){return t instanceof k&&t.kind===T.WithinEmbeddedContent},e.prototype.getNestedMode=function(t){var e=null,n=t,r=null;if(null!==n.embeddedContentType)this.modeService.isRegisteredMode(n.embeddedContentType)&&(e=this.modeService.getMode(n.embeddedContentType),e||(r=this.modeService.getOrCreateMode(n.embeddedContentType)));else{var i=null;i="script"===n.lastTagName?"text/javascript":"style"===n.lastTagName?"text/css":"text/plain",e=this.modeService.getMode(i)}return null===e&&(e=this.modeService.getMode("text/plain")),{mode:e,missingModePromise:r}},e.prototype.getLeavingNestedModeData=function(t,e){var n=e.lastTagName,r=new RegExp("<\\/"+n+"\\s*>","i"),i=r.exec(t);return null!==i?{nestedModeBuffer:t.substring(0,i.index),bufferAfterNestedMode:t.substring(i.index),stateAfterNestedMode:new k(this,T.Content,"","","","","")}:null},e.prototype.configure=function(t){return this.threadService.isInMainThread?this._configureWorkers(t):this._worker(function(e){return e._doConfigure(t)})},e.prototype._configureWorkers=function(t){return this._worker(function(e){return e._doConfigure(t)})},e.prototype.computeLinks=function(t){return this._worker(function(e){return e.computeLinks(t)})},e.prototype.formatRange=function(t,e,n){return this._worker(function(r){return r.format(t,e,n)})},e.prototype.computeInfo=function(t,e){return this._worker(function(n){return n.computeInfo(t,e)})},e.prototype.findReferences=function(t,e,n){return this._worker(function(r){return r.findReferences(t,e,n)})},e.prototype.getRangesToPosition=function(t,e){return this._worker(function(n){return n.getRangesToPosition(t,e)})},e.prototype.findDeclaration=function(t,e){return this._worker(function(n){return n.findDeclaration(t,e)})},e.prototype.findOccurrences=function(t,e,n){return void 0===n&&(n=!1),this._worker(function(r){return r.findOccurrences(t,e,n)})},e.prototype.suggest=function(t,e){return this._worker(function(n){return n.suggest(t,e)})},e.prototype.findColorDeclarations=function(t){return this._worker(function(e){return e.findColorDeclarations(t)})},e.prototype.getParameterHints=function(t,e){return this._worker(function(n){return n.getParameterHints(t,e)})},e.$_configureWorkers=a.AllWorkersAttr(e,e.prototype._configureWorkers),e.$computeLinks=a.OneWorkerAttr(e,e.prototype.computeLinks),e.$formatRange=a.OneWorkerAttr(e,e.prototype.formatRange),e.$computeInfo=a.OneWorkerAttr(e,e.prototype.computeInfo),e.$findReferences=a.OneWorkerAttr(e,e.prototype.findReferences),e.$getRangesToPosition=a.OneWorkerAttr(e,e.prototype.getRangesToPosition),e.$findDeclaration=a.OneWorkerAttr(e,e.prototype.findDeclaration),e.$findOccurrences=a.OneWorkerAttr(e,e.prototype.findOccurrences),e.$suggest=a.OneWorkerAttr(e,e.prototype.suggest),e.$findColorDeclarations=a.OneWorkerAttr(e,e.prototype.findColorDeclarations),e.$getParameterHints=a.OneWorkerAttr(e,e.prototype.getParameterHints),e=__decorate([__param(1,u.IInstantiationService),__param(2,s.IModeService),__param(3,f.IThreadService)],e)}(i.AbstractMode);e.HTMLMode=b});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c212f0908f3d29933317bbc3233568fbca7944b1/vs/languages/html/common/html.js.map
