/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/languages/less/common/lessTokenTypes",["require","exports"],function(e,t){"use strict";t.TOKEN_SELECTOR="entity.name.selector",t.TOKEN_SELECTOR_TAG="entity.name.tag",t.TOKEN_PROPERTY="support.type.property-name",t.TOKEN_VALUE="support.property-value",t.TOKEN_AT_KEYWORD="keyword.control.at-rule"});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)},__decorate=this&&this.__decorate||function(e,t,r,n){var o,i=arguments.length,s=3>i?t:null===n?n=Object.getOwnPropertyDescriptor(t,r):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,n);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(s=(3>i?o(s):i>3?o(t,r,s):o(t,r))||s);return i>3&&s&&Object.defineProperty(t,r,s),s},__param=this&&this.__param||function(e,t){return function(r,n){t(r,n,e)}};define("vs/languages/less/common/less",["require","exports","vs/editor/common/modes/monarch/monarch","vs/editor/common/modes/monarch/monarchCompile","vs/languages/less/common/lessTokenTypes","vs/editor/common/modes/abstractMode","vs/platform/thread/common/threadService","vs/editor/common/services/modeService","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/editor/common/services/modelService","vs/editor/common/modes/supports/declarationSupport","vs/editor/common/modes/supports/referenceSupport","vs/editor/common/modes/supports/suggestSupport","vs/editor/common/services/editorWorkerService"],function(e,t,r,n,o,i,s,a,c,u,p,l,d,f,m){"use strict";t.language={displayName:"LESS",name:"less",wordDefinition:/(#?-?\d*\.\d\w*%?)|([@#!.:]?[\w-?]+%?)|[@#!.]/g,defaultToken:"",lineComment:"//",blockCommentStart:"/*",blockCommentEnd:"*/",identifier:"-?-?([a-zA-Z]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))([\\w\\-]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))*",identifierPlus:"-?-?([a-zA-Z:.]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))([\\w\\-:.]|(\\\\(([0-9a-fA-F]{1,6}\\s?)|[^[0-9a-fA-F])))*",brackets:[{open:"{",close:"}",token:"punctuation.curly"},{open:"[",close:"]",token:"punctuation.bracket"},{open:"(",close:")",token:"punctuation.parenthesis"},{open:"<",close:">",token:"punctuation.angle"}],tokenizer:{root:[{include:"@nestedJSBegin"},["[ \\t\\r\\n]+",""],{include:"@comments"},{include:"@keyword"},{include:"@strings"},{include:"@numbers"},["[*_]?[a-zA-Z\\-\\s]+(?=:.*(;|(\\\\$)))",o.TOKEN_PROPERTY,"@attribute"],["url(\\-prefix)?\\(",{token:"function",bracket:"@open",next:"@urldeclaration"}],["[{}()\\[\\]]","@brackets"],["[,:;]","punctuation"],["#@identifierPlus",o.TOKEN_SELECTOR+".id"],["&",o.TOKEN_SELECTOR_TAG],["\\.@identifierPlus(?=\\()",o.TOKEN_SELECTOR+".class","@attribute"],["\\.@identifierPlus",o.TOKEN_SELECTOR+".class"],["@identifierPlus",o.TOKEN_SELECTOR_TAG],{include:"@operators"},["@(@identifier(?=[:,\\)]))","variable","@attribute"],["@(@identifier)","variable"],["@","key","@atRules"]],nestedJSBegin:[["``","punctuation.backtick"],["`",{token:"punctuation.backtick",bracket:"@open",next:"@nestedJSEnd",nextEmbedded:"text/javascript"}]],nestedJSEnd:[["`",{token:"punctuation.backtick",bracket:"@close",next:"@pop"}],[".",{token:"@rematch",next:"@javascript_block"}]],javascript_block:[["`",{token:"@rematch",next:"@pop",nextEmbedded:"@pop"}]],operators:[["[<>=\\+\\-\\*\\/\\^\\|\\~]","operator"]],keyword:[["(@[\\s]*import|![\\s]*important|true|false|when|iscolor|isnumber|isstring|iskeyword|isurl|ispixel|ispercentage|isem|hue|saturation|lightness|alpha|lighten|darken|saturate|desaturate|fadein|fadeout|fade|spin|mix|round|ceil|floor|percentage)\\b","keyword"]],urldeclaration:[{include:"@strings"},["[^)\r\n]+","string"],["\\)",{token:"tag",bracket:"@close",next:"@pop"}]],attribute:[{include:"@nestedJSBegin"},{include:"@comments"},{include:"@strings"},{include:"@numbers"},{include:"@keyword"},["[a-zA-Z\\-]+(?=\\()",o.TOKEN_VALUE,"@attribute"],[">","operator","@pop"],["@identifier",o.TOKEN_VALUE],{include:"@operators"},["@(@identifier)","variable"],["[)\\}]","@brackets","@pop"],["[{}()\\[\\]>]","@brackets"],["[;]","punctuation","@pop"],["[,=:]","punctuation"],["\\s",""],[".",o.TOKEN_VALUE]],comments:[["\\/\\*","comment","@comment"],["\\/\\/+.*","comment"]],comment:[["\\*\\/","comment","@pop"],[".","comment"]],numbers:[["(\\d*\\.)?\\d+([eE][\\-+]?\\d+)?",{token:o.TOKEN_VALUE+".numeric",next:"@units"}],["#[0-9a-fA-F_]+(?!\\w)",o.TOKEN_VALUE+".rgb-value"]],units:[["((em|ex|ch|rem|vw|vh|vm|cm|mm|in|px|pt|pc|deg|grad|rad|turn|s|ms|Hz|kHz|%)\\b)?",o.TOKEN_VALUE+".unit","@pop"]],strings:[['~?"',{token:"string.punctuation",bracket:"@open",next:"@stringsEndDoubleQuote"}],["~?'",{token:"string.punctuation",bracket:"@open",next:"@stringsEndQuote"}]],stringsEndDoubleQuote:[['\\\\"',"string"],['"',{token:"string.punctuation",next:"@popall",bracket:"@close"}],[".","string"]],stringsEndQuote:[["\\\\'","string"],["'",{token:"string.punctuation",next:"@popall",bracket:"@close"}],[".","string"]],atRules:[{include:"@comments"},{include:"@strings"},["[()]","punctuation"],["[\\{;]","punctuation","@pop"],[".","key"]]}};var g=function(e){function r(r,s,a,c,u,p){var m=this;e.call(this,r.id,n.compile(t.language),c,u,p),this._modeWorkerManager=new i.ModeWorkerManager(r,"vs/languages/less/common/lessWorker","LessWorker","vs/languages/css/common/cssWorker",s),this._threadService=a,this.modeService=c,this.extraInfoSupport=this,this.inplaceReplaceSupport=this,this.configSupport=this,this.referenceSupport=new d.ReferenceSupport(this.getId(),{tokens:[o.TOKEN_PROPERTY+".less",o.TOKEN_VALUE+".less","variable.less",o.TOKEN_SELECTOR+".class.less",o.TOKEN_SELECTOR+".id.less","selector.less"],findReferences:function(e,t,r){return m.findReferences(e,t)}}),this.logicalSelectionSupport=this,this.declarationSupport=new l.DeclarationSupport(this.getId(),{tokens:["variable.less",o.TOKEN_SELECTOR+".class.less",o.TOKEN_SELECTOR+".id.less","selector.less"],findDeclaration:function(e,t){return m.findDeclaration(e,t)}}),this.outlineSupport=this,this.suggestSupport=new f.SuggestSupport(this.getId(),{triggerCharacters:[],excludeTokens:["comment.less","string.less"],suggest:function(e,t){return m.suggest(e,t)}})}return __extends(r,e),r.prototype.creationDone=function(){this._threadService.isInMainThread&&this._pickAWorkerToValidate()},r.prototype._worker=function(e){return this._modeWorkerManager.worker(e)},r.prototype.configure=function(e){return this._threadService.isInMainThread?this._configureWorkers(e):this._worker(function(t){return t._doConfigure(e)})},r.prototype._configureWorkers=function(e){return this._worker(function(t){return t._doConfigure(e)})},r.prototype.navigateValueSet=function(e,t,r){return this._worker(function(n){return n.navigateValueSet(e,t,r)})},r.prototype._pickAWorkerToValidate=function(){return this._worker(function(e){return e.enableValidator()})},r.prototype.findReferences=function(e,t){return this._worker(function(r){return r.findReferences(e,t)})},r.prototype.suggest=function(e,t){return this._worker(function(r){return r.suggest(e,t)})},r.prototype.getRangesToPosition=function(e,t){return this._worker(function(r){return r.getRangesToPosition(e,t)})},r.prototype.computeInfo=function(e,t){return this._worker(function(r){return r.computeInfo(e,t)})},r.prototype.getOutline=function(e){return this._worker(function(t){return t.getOutline(e)})},r.prototype.findDeclaration=function(e,t){return this._worker(function(r){return r.findDeclaration(e,t)})},r.prototype.findColorDeclarations=function(e){return this._worker(function(t){return t.findColorDeclarations(e)})},r.$_configureWorkers=s.AllWorkersAttr(r,r.prototype._configureWorkers),r.$navigateValueSet=s.OneWorkerAttr(r,r.prototype.navigateValueSet),r.$_pickAWorkerToValidate=s.OneWorkerAttr(r,r.prototype._pickAWorkerToValidate,u.ThreadAffinity.Group1),r.$findReferences=s.OneWorkerAttr(r,r.prototype.findReferences),r.$suggest=s.OneWorkerAttr(r,r.prototype.suggest),r.$getRangesToPosition=s.OneWorkerAttr(r,r.prototype.getRangesToPosition),r.$computeInfo=s.OneWorkerAttr(r,r.prototype.computeInfo),r.$getOutline=s.OneWorkerAttr(r,r.prototype.getOutline),r.$findDeclaration=s.OneWorkerAttr(r,r.prototype.findDeclaration),r.$findColorDeclarations=s.OneWorkerAttr(r,r.prototype.findColorDeclarations),r=__decorate([__param(1,c.IInstantiationService),__param(2,u.IThreadService),__param(3,a.IModeService),__param(4,p.IModelService),__param(5,m.IEditorWorkerService)],r)}(r.MonarchMode);t.LESSMode=g});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c212f0908f3d29933317bbc3233568fbca7944b1/vs/languages/less/common/less.js.map
