/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)};define("vs/languages/sass/common/parser/sassScanner",["require","exports","vs/languages/css/common/parser/cssScanner"],function(e,t,r){"use strict";var s="/".charCodeAt(0),n="\n".charCodeAt(0),i="\r".charCodeAt(0),a="\f".charCodeAt(0),o="$".charCodeAt(0),l="#".charCodeAt(0),c="{".charCodeAt(0),p="=".charCodeAt(0),u="!".charCodeAt(0),h="<".charCodeAt(0),f=">".charCodeAt(0),d=".".charCodeAt(0),y=r.TokenType.CustomToken;t.VariableName=y++,t.InterpolationFunction=y++,t.Default=y++,t.EqualsOperator=y++,t.NotEqualsOperator=y++,t.GreaterEqualsOperator=y++,t.SmallerEqualsOperator=y++,t.Ellipsis=y++;var m=function(e){function y(){e.apply(this,arguments)}return __extends(y,e),y.prototype.scan=function(){var s=this.trivia();if(null!==s)return s;var n=this.stream.pos();if(this.stream.advanceIfChar(o)){var i=["$"];if(this.ident(i))return this.finishToken(n,t.VariableName,i.join(""));this.stream.goBackTo(n)}return this.stream.advanceIfChars([l,c])?this.finishToken(n,t.InterpolationFunction):this.stream.advanceIfChars([p,p])?this.finishToken(n,t.EqualsOperator):this.stream.advanceIfChars([u,p])?this.finishToken(n,t.NotEqualsOperator):this.stream.advanceIfChar(h)?this.stream.advanceIfChar(p)?this.finishToken(n,t.SmallerEqualsOperator):this.finishToken(n,r.TokenType.Delim):this.stream.advanceIfChar(f)?this.stream.advanceIfChar(p)?this.finishToken(n,t.GreaterEqualsOperator):this.finishToken(n,r.TokenType.Delim):this.stream.advanceIfChars([d,d,d])?this.finishToken(n,t.Ellipsis):e.prototype.scan.call(this)},y.prototype.comment=function(){return e.prototype.comment.call(this)?!0:this.stream.advanceIfChars([s,s])?(this.stream.advanceWhileChar(function(e){switch(e){case n:case i:case a:return!1;default:return!0}}),!0):!1},y}(r.Scanner);t.SassScanner=m}),define("vs/nls!vs/languages/sass/common/parser/sassErrors",["vs/nls","vs/nls!vs/languages/sass/common/sassWorker"],function(e,t){return e.create("vs/languages/sass/common/parser/sassErrors",t)}),define("vs/languages/sass/common/parser/sassErrors",["require","exports","vs/nls!vs/languages/sass/common/parser/sassErrors"],function(e,t,r){"use strict";var s=function(){function e(e,t){this.id=e,this.message=t}return e}();t.SassIssueType=s,t.ParseError={FromExpected:new s("sass-fromexpected",r.localize(0,null)),ThroughOrToExpected:new s("sass-throughexpected",r.localize(1,null)),InExpected:new s("sass-fromexpected",r.localize(2,null))}});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)};define("vs/languages/sass/common/parser/sassParser",["require","exports","./sassScanner","./sassErrors","vs/languages/css/common/parser/cssScanner","vs/languages/css/common/parser/cssParser","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/parser/cssErrors"],function(e,t,r,s,n,i,a,o){"use strict";var l=function(e){function t(){e.call(this,new r.SassScanner)}return __extends(t,e),t.prototype._parseStylesheetStatement=function(){return e.prototype._parseStylesheetStatement.call(this)||this._parseVariableDeclaration()||this._parseWarnAndDebug()||this._parseControlStatement()||this._parseMixinDeclaration()||this._parseMixinContent()||this._parseMixinReference()||this._parseFunctionDeclaration()},t.prototype._parseImport=function(){var e=this.create(a.Import);if(!this.accept(n.TokenType.AtKeyword,"@import"))return null;if(!this.accept(n.TokenType.URI)&&!this.accept(n.TokenType.String))return this.finish(e,o.ParseError.URIOrStringExpected);for(;this.accept(n.TokenType.Comma);)if(!this.accept(n.TokenType.URI)&&!this.accept(n.TokenType.String))return this.finish(e,o.ParseError.URIOrStringExpected);return e.setMedialist(this._parseMediaList()),this.finish(e)},t.prototype._parseVariableDeclaration=function(e){void 0===e&&(e=[]);var t=this.create(a.VariableDeclaration);return t.setVariable(this._parseVariable())?this.accept(n.TokenType.Colon,":")?(t.colonPosition=this.prevToken.offset,t.setValue(this._parseExpr())?this.accept(n.TokenType.Exclamation)&&!this.accept(n.TokenType.Ident,"default",!0)?this.finish(t,o.ParseError.UnknownKeyword):this.finish(t):this.finish(t,o.ParseError.VariableValueExpected,[],e)):this.finish(t,o.ParseError.ColonExpected):null},t.prototype._parseMediaFeatureName=function(){return this._parseFunction()||this._parseIdent()||this._parseVariable()},t.prototype._parseKeyframeSelector=function(){return e.prototype._parseKeyframeSelector.call(this)||this._parseMixinContent()},t.prototype._parseVariable=function(){var e=this.create(a.Variable);return this.accept(r.VariableName)?e:null},t.prototype._parseIdent=function(e){var t=this.create(a.Identifier);t.referenceTypes=e;for(var r=!1;(this.accept(n.TokenType.Ident)||t.addChild(this._parseInterpolation()))&&(r=!0,!this.hasWhitespace()&&this.accept(n.TokenType.Delim,"-"),!this.hasWhitespace()););return r?this.finish(t):null},t.prototype._parseTerm=function(){var t=e.prototype._parseTerm.call(this);return t?t:(t=this.create(a.Term),t.setExpression(this._parseVariable())?this.finish(t):null)},t.prototype._parseInterpolation=function(){var e=this.create(a.Interpolation);return this.accept(r.InterpolationFunction)?e.addChild(this._parseBinaryExpr())?this.accept(n.TokenType.CurlyR)?this.finish(e):this.finish(e,o.ParseError.RightCurlyExpected):this.finish(e,o.ParseError.ExpressionExpected):null},t.prototype._parseOperator=function(){var t=this.createNode(a.NodeType.Operator);if(this.peek(r.EqualsOperator)||this.peek(r.NotEqualsOperator)||this.peek(r.GreaterEqualsOperator)||this.peek(r.SmallerEqualsOperator)||this.peek(n.TokenType.Delim,">")||this.peek(n.TokenType.Delim,"<")||this.peek(n.TokenType.Ident,"and")||this.peek(n.TokenType.Ident,"or")||this.peek(n.TokenType.Delim,"%")){var t=this.createNode(a.NodeType.Operator);return this.consumeToken(),this.finish(t)}return e.prototype._parseOperator.call(this)},t.prototype._parseUnaryOperator=function(){if(this.peek(n.TokenType.Ident,"not")){var t=this.create(a.Node);return this.consumeToken(),this.finish(t)}return e.prototype._parseUnaryOperator.call(this)},t.prototype._parseRuleSetDeclaration=function(){return this.peek(n.TokenType.AtKeyword)?this._parseKeyframe()||this._parseImport()||this._parseMedia()||this._parseFontFace()||this._parseWarnAndDebug()||this._parseControlStatement()||this._parseFunctionDeclaration()||this._parseExtends()||this._parseMixinReference()||this._parseMixinContent()||this._parseMixinDeclaration():this._parseVariableDeclaration()||this._tryParseRuleset(!0)||this._parseDeclaration()},t.prototype._parseDeclaration=function(e){var t=this.create(a.Declaration);if(!t.setProperty(this._parseProperty()))return null;if(!this.accept(n.TokenType.Colon,":"))return this.finish(t,o.ParseError.ColonExpected,[n.TokenType.Colon],e);t.colonPosition=this.prevToken.offset;var r=!1;if(t.setValue(this._parseExpr())&&(r=!0,t.addChild(this._parsePrio())),this.peek(n.TokenType.CurlyL))t.setNestedProperties(this._parseNestedProperties());else if(!r)return this.finish(t,o.ParseError.PropertyValueExpected);return this.peek(n.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)},t.prototype._parseNestedProperties=function(){var e=this.create(a.NestedProperties);return this._parseBody(e,this._parseDeclaration.bind(this))},t.prototype._parseExtends=function(){var e=this.create(a.ExtendsReference);return this.accept(n.TokenType.AtKeyword,"@extend")?e.setSelector(this._parseSimpleSelector())?this.accept(n.TokenType.Exclamation)&&!this.accept(n.TokenType.Ident,"optional",!0)?this.finish(e,o.ParseError.UnknownKeyword):this.finish(e):this.finish(e,o.ParseError.SelectorExpected):null},t.prototype._parseSimpleSelectorBody=function(){return this._parseSelectorCombinator()||this._parseSelectorPlaceholder()||e.prototype._parseSimpleSelectorBody.call(this)},t.prototype._parseSelectorCombinator=function(){var e=this.createNode(a.NodeType.SelectorCombinator);if(this.accept(n.TokenType.Delim,"&")){for(;!this.hasWhitespace()&&(this.accept(n.TokenType.Delim,"-")||e.addChild(this._parseIdent())||this.accept(n.TokenType.Delim,"&")););return this.finish(e)}return null},t.prototype._parseSelectorPlaceholder=function(){var e=this.createNode(a.NodeType.SelectorPlaceholder);return this.accept(n.TokenType.Delim,"%")?(this._parseIdent(),this.finish(e)):null},t.prototype._parseWarnAndDebug=function(){if(!this.peek(n.TokenType.AtKeyword,"@debug")&&!this.peek(n.TokenType.AtKeyword,"@warn"))return null;var e=this.createNode(a.NodeType.Debug);return this.consumeToken(),e.addChild(this._parseExpr()),this.finish(e)},t.prototype._parseControlStatement=function(e){return void 0===e&&(e=this._parseRuleSetDeclaration.bind(this)),this.peek(n.TokenType.AtKeyword)?this._parseIfStatement(e)||this._parseForStatement(e)||this._parseEachStatement(e)||this._parseWhileStatement(e):null},t.prototype._parseIfStatement=function(e){return this.peek(n.TokenType.AtKeyword,"@if")?this._internalParseIfStatement(e):null},t.prototype._internalParseIfStatement=function(e){var t=this.create(a.IfStatement);if(this.consumeToken(),!t.setExpression(this._parseBinaryExpr()))return this.finish(t,o.ParseError.ExpressionExpected);if(this._parseBody(t,e),this.accept(n.TokenType.AtKeyword,"@else"))if(this.peek(n.TokenType.Ident,"if"))t.setElseClause(this._internalParseIfStatement(e));else if(this.peek(n.TokenType.CurlyL)){var r=this.create(a.ElseStatement);this._parseBody(r,e),t.setElseClause(r)}return this.finish(t)},t.prototype._parseForStatement=function(e){if(!this.peek(n.TokenType.AtKeyword,"@for"))return null;var t=this.create(a.ForStatement);return this.consumeToken(),t.setVariable(this._parseVariable())?this.accept(n.TokenType.Ident,"from")?t.addChild(this._parseBinaryExpr())?this.accept(n.TokenType.Ident,"to")||this.accept(n.TokenType.Ident,"through")?t.addChild(this._parseBinaryExpr())?this._parseBody(t,e):this.finish(t,o.ParseError.ExpressionExpected,[n.TokenType.CurlyR]):this.finish(t,s.ParseError.ThroughOrToExpected,[n.TokenType.CurlyR]):this.finish(t,o.ParseError.ExpressionExpected,[n.TokenType.CurlyR]):this.finish(t,s.ParseError.FromExpected,[n.TokenType.CurlyR]):this.finish(t,o.ParseError.VariableNameExpected,[n.TokenType.CurlyR])},t.prototype._parseEachStatement=function(e){if(!this.peek(n.TokenType.AtKeyword,"@each"))return null;var t=this.create(a.EachStatement);return this.consumeToken(),t.setVariable(this._parseVariable())?this.accept(n.TokenType.Ident,"in")?t.addChild(this._parseExpr())?this._parseBody(t,e):this.finish(t,o.ParseError.ExpressionExpected,[n.TokenType.CurlyR]):this.finish(t,s.ParseError.InExpected,[n.TokenType.CurlyR]):this.finish(t,o.ParseError.VariableNameExpected,[n.TokenType.CurlyR])},t.prototype._parseWhileStatement=function(e){if(!this.peek(n.TokenType.AtKeyword,"@while"))return null;var t=this.create(a.WhileStatement);return this.consumeToken(),t.addChild(this._parseBinaryExpr())?this._parseBody(t,e):this.finish(t,o.ParseError.ExpressionExpected,[n.TokenType.CurlyR])},t.prototype._parseFunctionBodyDeclaration=function(){return this._parseVariableDeclaration()||this._parseReturnStatement()||this._parseControlStatement(this._parseFunctionBodyDeclaration.bind(this))},t.prototype._parseFunctionDeclaration=function(){if(!this.peek(n.TokenType.AtKeyword,"@function"))return null;var e=this.create(a.FunctionDeclaration);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([a.ReferenceType.Function])))return this.finish(e,o.ParseError.IdentifierExpected,[n.TokenType.CurlyR]);if(!this.accept(n.TokenType.ParenthesisL))return this.finish(e,o.ParseError.LeftParenthesisExpected,[n.TokenType.CurlyR]);if(e.getParameters().addChild(this._parseParameterDeclaration()))for(;this.accept(n.TokenType.Comma);)if(!e.getParameters().addChild(this._parseParameterDeclaration()))return this.finish(e,o.ParseError.VariableNameExpected);return this.accept(n.TokenType.ParenthesisR)?this._parseBody(e,this._parseFunctionBodyDeclaration.bind(this)):this.finish(e,o.ParseError.RightParenthesisExpected,[n.TokenType.CurlyR])},t.prototype._parseReturnStatement=function(){if(!this.peek(n.TokenType.AtKeyword,"@return"))return null;var e=this.createNode(a.NodeType.ReturnStatement);return this.consumeToken(),e.addChild(this._parseExpr())?this.finish(e):this.finish(e,o.ParseError.ExpressionExpected)},t.prototype._parseMixinDeclaration=function(){if(!this.peek(n.TokenType.AtKeyword,"@mixin"))return null;var e=this.create(a.MixinDeclaration);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([a.ReferenceType.Mixin])))return this.finish(e,o.ParseError.IdentifierExpected,[n.TokenType.CurlyR]);if(this.accept(n.TokenType.ParenthesisL)){if(e.getParameters().addChild(this._parseParameterDeclaration()))for(;this.accept(n.TokenType.Comma);)if(!e.getParameters().addChild(this._parseParameterDeclaration()))return this.finish(e,o.ParseError.VariableNameExpected);if(!this.accept(n.TokenType.ParenthesisR))return this.finish(e,o.ParseError.RightParenthesisExpected,[n.TokenType.CurlyR])}return this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},t.prototype._parseParameterDeclaration=function(){var e=this.create(a.FunctionParameter);return e.setIdentifier(this._parseVariable())?(this.accept(r.Ellipsis),this.accept(n.TokenType.Colon)&&!e.setDefaultValue(this._parseExpr(!0))?this.finish(e,o.ParseError.VariableValueExpected,[],[n.TokenType.Comma,n.TokenType.ParenthesisR]):this.finish(e)):null},t.prototype._parseMixinContent=function(){if(!this.peek(n.TokenType.AtKeyword,"@content"))return null;var e=this.createNode(a.NodeType.MixinContent);return this.consumeToken(),this.finish(e)},t.prototype._parseMixinReference=function(){if(!this.peek(n.TokenType.AtKeyword,"@include"))return null;var e=this.create(a.MixinReference);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([a.ReferenceType.Mixin])))return this.finish(e,o.ParseError.IdentifierExpected,[n.TokenType.CurlyR]);if(this.accept(n.TokenType.ParenthesisL)){if(e.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(n.TokenType.Comma);)if(!e.getArguments().addChild(this._parseFunctionArgument()))return this.finish(e,o.ParseError.ExpressionExpected);if(!this.accept(n.TokenType.ParenthesisR))return this.finish(e,o.ParseError.RightParenthesisExpected)}if(this.peek(n.TokenType.CurlyL)){var t=this.create(a.BodyDeclaration);this._parseBody(t,this._parseMixinReferenceBodyStatement.bind(this)),e.setContent(t)}return this.finish(e)},t.prototype._parseMixinReferenceBodyStatement=function(){return this._parseRuleSetDeclaration()||this._parseKeyframeSelector()},t.prototype._parseFunctionArgument=function(){var e=this.create(a.FunctionArgument),t=this.mark(),s=this._parseVariable();if(s)if(this.accept(n.TokenType.Colon))e.setIdentifier(s);else{if(this.accept(r.Ellipsis))return e.setValue(s),this.finish(e);this.restoreAtMark(t)}return e.setValue(this._parseExpr(!0))?this.finish(e):null},t}(i.Parser);t.SassParser=l}),define("vs/nls!vs/languages/sass/common/services/intelliSense",["vs/nls","vs/nls!vs/languages/sass/common/sassWorker"],function(e,t){return e.create("vs/languages/sass/common/services/intelliSense",t)});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)};define("vs/languages/sass/common/services/intelliSense",["require","exports","vs/languages/css/common/services/intelliSense","vs/nls!vs/languages/sass/common/services/intelliSense"],function(e,t,r,s){"use strict";var n=function(e){function t(){e.call(this,"$")}return __extends(t,e),t.prototype.createFunctionProposals=function(e,r){var s=function(e,r){return r+": {{"+(t.variableDefaults[r]||"")+"}}"};return e.forEach(function(e){r.push({label:e.func.substr(0,e.func.indexOf("(")),typeLabel:e.func,documentationLabel:e.desc,codeSnippet:e.func.replace(/\[?(\$\w+)\]?/g,s),type:"function"})}),r},t.prototype.getCompletionsForSelector=function(r,s){return this.createFunctionProposals(t.selectorFuncs,s),e.prototype.getCompletionsForSelector.call(this,r,s)},t.prototype.getTermProposals=function(r){return this.createFunctionProposals(t.builtInFuncs,r),e.prototype.getTermProposals.call(this,r)},t.prototype.getColorProposals=function(r,s){return this.createFunctionProposals(t.colorProposals,s),e.prototype.getColorProposals.call(this,r,s)},t.prototype.getCompletionsForDeclarationProperty=function(t){return this.getCompletionsForSelector(null,t),e.prototype.getCompletionsForDeclarationProperty.call(this,t)},t.variableDefaults={$red:"1",$green:"2",$blue:"3",$alpha:"1.0",$color:"$color",$weight:"0.5",$hue:"0",$saturation:"0%",$lightness:"0%",$degrees:"0",$amount:"0",$string:'""',$substring:'"s"',$number:"0",$limit:"1"},t.colorProposals=[{func:"red($color)",desc:s.localize(0,null)},{func:"green($color)",desc:s.localize(1,null)},{func:"blue($color)",desc:s.localize(2,null)},{func:"mix($color, $color, [$weight])",desc:s.localize(3,null)},{func:"hue($color)",desc:s.localize(4,null)},{func:"saturation($color)",desc:s.localize(5,null)},{func:"lightness($color)",desc:s.localize(6,null)},{func:"adjust-hue($color, $degrees)",desc:s.localize(7,null)},{func:"lighten($color, $amount)",desc:s.localize(8,null)},{func:"darken($color, $amount)",desc:s.localize(9,null)},{func:"saturate($color, $amount)",desc:s.localize(10,null)},{func:"desaturate($color, $amount)",desc:s.localize(11,null)},{func:"grayscale($color)",desc:s.localize(12,null)},{func:"complement($color)",desc:s.localize(13,null)},{func:"invert($color)",desc:s.localize(14,null)},{func:"alpha($color)",desc:s.localize(15,null)},{func:"opacity($color)",desc:"Gets the alpha component (opacity) of a color."},{func:"rgba($color, $alpha)",desc:s.localize(16,null)},{func:"opacify($color, $amount)",desc:s.localize(17,null)},{func:"fade-in($color, $amount)",desc:s.localize(18,null)},{func:"transparentize($color, $amount) / fade-out($color, $amount)",desc:s.localize(19,null)},{func:"adjust-color($color, [$red], [$green], [$blue], [$hue], [$saturation], [$lightness], [$alpha])",desc:s.localize(20,null)},{func:"scale-color($color, [$red], [$green], [$blue], [$saturation], [$lightness], [$alpha])",desc:s.localize(21,null)},{func:"change-color($color, [$red], [$green], [$blue], [$hue], [$saturation], [$lightness], [$alpha])",desc:s.localize(22,null)},{func:"ie-hex-str($color)",desc:s.localize(23,null)}],t.selectorFuncs=[{func:"selector-nest($selectors…)",desc:s.localize(24,null)},{func:"selector-append($selectors…)",desc:s.localize(25,null)},{func:"selector-extend($selector, $extendee, $extender)",desc:s.localize(26,null)},{func:"selector-replace($selector, $original, $replacement)",desc:s.localize(27,null)},{func:"selector-unify($selector1, $selector2)",desc:s.localize(28,null)},{func:"is-superselector($super, $sub)",desc:s.localize(29,null)},{func:"simple-selectors($selector)",desc:s.localize(30,null)},{func:"selector-parse($selector)",desc:s.localize(31,null)}],t.builtInFuncs=[{func:"unquote($string)",desc:s.localize(32,null)},{func:"quote($string)",desc:s.localize(33,null)},{func:"str-length($string)",desc:s.localize(34,null)},{func:"str-insert($string, $insert, $index)",desc:s.localize(35,null)},{func:"str-index($string, $substring)",desc:s.localize(36,null)},{func:"str-slice($string, $start-at, [$end-at])",desc:s.localize(37,null)},{func:"to-upper-case($string)",desc:s.localize(38,null)},{func:"to-lower-case($string)",desc:s.localize(39,null)},{func:"percentage($number)",desc:s.localize(40,null)},{func:"round($number)",desc:s.localize(41,null)},{func:"ceil($number)",desc:s.localize(42,null)},{func:"floor($number)",desc:s.localize(43,null)},{func:"abs($number)",desc:s.localize(44,null)},{func:"min($numbers)",desc:s.localize(45,null)},{func:"max($numbers)",desc:s.localize(46,null)},{func:"random([$limit])",desc:s.localize(47,null)},{func:"length($list)",desc:s.localize(48,null)},{func:"nth($list, $n)",desc:s.localize(49,null)},{func:"set-nth($list, $n, $value)",desc:s.localize(50,null)},{func:"join($list1, $list2, [$separator])",desc:s.localize(51,null)},{func:"append($list1, $val, [$separator])",desc:s.localize(52,null)},{func:"zip($lists)",desc:s.localize(53,null)},{func:"index($list, $value)",desc:s.localize(54,null)},{func:"list-separator(#list)",desc:s.localize(55,null)},{func:"map-get($map, $key)",desc:s.localize(56,null)},{func:"map-merge($map1, $map2)",desc:s.localize(57,null)},{func:"map-remove($map, $keys)",desc:s.localize(58,null)},{func:"map-keys($map)",desc:s.localize(59,null)},{func:"map-values($map)",desc:s.localize(60,null)},{func:"map-has-key($map, $key)",desc:s.localize(61,null)},{func:"keywords($args)",desc:s.localize(62,null)},{func:"feature-exists($feature)",desc:s.localize(63,null)},{func:"variable-exists($name)",desc:s.localize(64,null)},{func:"global-variable-exists($name)",desc:s.localize(65,null)},{func:"function-exists($name)",desc:s.localize(66,null)},{func:"mixin-exists($name)",desc:s.localize(67,null)},{func:"inspect($value)",desc:s.localize(68,null)},{func:"type-of($value)",desc:s.localize(69,null)},{func:"unit($number)",desc:s.localize(70,null)},{func:"unitless($number)",desc:s.localize(71,null)},{func:"comparable($number1, $number2)",desc:s.localize(72,null)},{func:"call($name, $args…)",desc:s.localize(73,null)}],t}(r.CSSIntellisense);t.SASSIntellisense=n});var __extends=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)};define("vs/languages/sass/common/sassWorker",["require","exports","vs/languages/css/common/cssWorker","./parser/sassParser","./services/intelliSense"],function(e,t,r,s,n){"use strict";var i=function(e){function t(){e.apply(this,arguments)}return __extends(t,e),t.prototype.createIntellisense=function(){return new n.SASSIntellisense},t.prototype.createParser=function(){return new s.SassParser},t}(r.CSSWorker);t.SassWorker=i});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c212f0908f3d29933317bbc3233568fbca7944b1/vs/languages/sass/common/sassWorker.js.map
