/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
define("vs/base/common/platform",["require","exports"],function(e,t){"use strict";function r(){return"undefined"!=typeof g.Worker}var n=!1,o=!1,i=!1,a=!1,s=!1,u=!1,c=!1,f=void 0,h=void 0;if(t.LANGUAGE_DEFAULT="en","object"==typeof process){n="win32"===process.platform,o="darwin"===process.platform,i="linux"===process.platform,a=!n&&0===process.getuid();var p=process.env.VSCODE_NLS_CONFIG;if(p)try{var l=JSON.parse(p),d=l.availableLanguages["*"];f=l.locale,h=d?d:t.LANGUAGE_DEFAULT}catch(y){}s=!0}else if("object"==typeof navigator){var v=navigator.userAgent;n=v.indexOf("Windows")>=0,o=v.indexOf("Macintosh")>=0,i=v.indexOf("Linux")>=0,u=!0,f=navigator.language,h=f,c=!!self.QUnit}!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={}));var m=t.Platform;t._platform=m.Web,s&&(o?t._platform=m.Mac:n?t._platform=m.Windows:i&&(t._platform=m.Linux)),t.isWindows=n,t.isMacintosh=o,t.isLinux=i,t.isRootUser=a,t.isNative=s,t.isWeb=u,t.isQunit=c,t.platform=t._platform,t.language=h,t.locale=f;var g="object"==typeof self?self:global;t.globals=g,t.hasWebWorkerSupport=r,t.setTimeout=g.setTimeout.bind(g),t.clearTimeout=g.clearTimeout.bind(g),t.setInterval=g.setInterval.bind(g),t.clearInterval=g.clearInterval.bind(g)}),define("vs/base/common/types",["require","exports"],function(e,t){"use strict";function r(e){return Array.isArray?Array.isArray(e):!(!e||"number"!=typeof e.length||e.constructor!==Array)}function n(e){return"string"==typeof e||e instanceof String}function o(e){return r(e)&&e.every(function(e){return n(e)})}function i(e){return"undefined"==typeof e||null===e?!1:"[object Object]"===Object.prototype.toString.call(e)}function a(e){return("number"==typeof e||e instanceof Number)&&!isNaN(e)}function s(e){return e===!0||e===!1}function u(e){return"undefined"==typeof e}function c(e){return u(e)||null===e}function f(e){if(!i(e))return!1;for(var t in e)if(v.call(e,t))return!1;return!0}function h(e){return"[object Function]"===Object.prototype.toString.call(e)}function p(){for(var e=[],t=0;t<arguments.length;t++)e[t-0]=arguments[t];return e&&e.length>0&&e.every(function(e){return h(e)})}function l(e,t){for(var r=Math.min(e.length,t.length),n=0;r>n;n++)d(e[n],t[n])}function d(e,t){if("string"==typeof t){if(typeof e!==t)throw new Error("argument does not match constraint: typeof "+t)}else if("function"==typeof t){if(e instanceof t)return;if(e&&e.constructor===t)return;if(1===t.length&&t.call(void 0,e)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function y(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];var n=Object.create(e.prototype);return e.apply(n,t),n}t.isArray=r,t.isString=n,t.isStringArray=o,t.isObject=i,t.isNumber=a,t.isBoolean=s,t.isUndefined=u,t.isUndefinedOrNull=c;var v=Object.prototype.hasOwnProperty;t.isEmptyObject=f,t.isFunction=h,t.areFunctions=p,t.validateConstraints=l,t.validateConstraint=d,t.create=y}),define("vs/base/common/objects",["require","exports","vs/base/common/types"],function(e,t,r){"use strict";function n(e){if(!e||"object"!=typeof e)return e;if(e instanceof RegExp)return e;var t=Array.isArray(e)?[]:{};return Object.keys(e).forEach(function(r){e[r]&&"object"==typeof e[r]?t[r]=n(e[r]):t[r]=e[r]}),t}function o(e){if(!e||"object"!=typeof e)return e;var t=Array.isArray(e)?[]:{};return Object.getOwnPropertyNames(e).forEach(function(r){e[r]&&"object"==typeof e[r]?t[r]=o(e[r]):t[r]=e[r]}),t}function i(e,t){return a(e,t,[])}function a(e,t,n){if(r.isUndefinedOrNull(e))return e;var o=t(e);if("undefined"!=typeof o)return o;if(r.isArray(e)){for(var i=[],s=0;s<e.length;s++)i.push(a(e[s],t,n));return i}if(r.isObject(e)){if(n.indexOf(e)>=0)throw new Error("Cannot clone recursive data-structure");n.push(e);var u={};for(var c in e)g.call(e,c)&&(u[c]=a(e[c],t,n));return n.pop(),u}return e}function s(e,t,n){return void 0===n&&(n=!0),r.isObject(e)?(r.isObject(t)&&Object.keys(t).forEach(function(o){o in e?n&&(r.isObject(e[o])&&r.isObject(t[o])?s(e[o],t[o],n):e[o]=t[o]):e[o]=t[o]}),e):t}function u(e){for(var t=[],r=1;r<arguments.length;r++)t[r-1]=arguments[r];return t.forEach(function(t){return Object.keys(t).forEach(function(r){return e[r]=t[r]})}),e}function c(e,t,r){return void 0===r&&(r=function(e){return e}),e.reduce(function(e,n){return u(e,(o={},o[t(n)]=r(n),o));var o},Object.create(null))}function f(e,t){return s(n(t),e||{})}function h(e,t){if(e===t)return!0;if(null===e||void 0===e||null===t||void 0===t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;var r,n;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(r=0;r<e.length;r++)if(!h(e[r],t[r]))return!1}else{var o=[];for(n in e)o.push(n);o.sort();var i=[];for(n in t)i.push(n);if(i.sort(),!h(o,i))return!1;for(r=0;r<o.length;r++)if(!h(e[o[r]],t[o[r]]))return!1}return!0}function p(e,t,r){"undefined"==typeof e[t]&&(e[t]=r)}function l(e){for(var t={},r=0;r<e.length;++r)t[e[r]]=!0;return t}function d(e,t){void 0===t&&(t=!1),t&&(e=e.map(function(e){return e.toLowerCase()}));var r=l(e);return t?function(e){return void 0!==r[e.toLowerCase()]&&r.hasOwnProperty(e.toLowerCase())}:function(e){return void 0!==r[e]&&r.hasOwnProperty(e)}}function y(e,t){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t=t||function(){};var n=e.prototype,o=t.prototype;t.prototype=Object.create(n);for(var r in o)o.hasOwnProperty(r)&&Object.defineProperty(t.prototype,r,Object.getOwnPropertyDescriptor(o,r));Object.defineProperty(t.prototype,"constructor",{value:t,writable:!0,configurable:!0,enumerable:!0})}function v(e){var t=[];return JSON.stringify(e,function(e,n){if(r.isObject(n)||Array.isArray(n)){if(-1!==t.indexOf(n))return"[Circular]";t.push(n)}return n})}function m(e,t,r){void 0===r&&(r=null);var n=t(e);return"undefined"==typeof n?r:n}t.clone=n,t.deepClone=o;var g=Object.prototype.hasOwnProperty;t.cloneAndChange=i,t.mixin=s,t.assign=u,t.toObject=c,t.withDefaults=f,t.equals=h,t.ensureProperty=p,t.arrayToHash=l,t.createKeywordMatcher=d,t.derive=y,t.safeStringify=v,t.getOrDefault=m}),define("vs/base/common/uri",["require","exports","vs/base/common/platform"],function(e,t,r){"use strict";function n(e){return"%"+e.charCodeAt(0).toString(16).toUpperCase()}function o(e){return encodeURIComponent(e).replace(/[!'()*]/g,n)}function i(e){return e}var a=function(){function e(){this._scheme=e._empty,this._authority=e._empty,this._path=e._empty,this._query=e._empty,this._fragment=e._empty,this._formatted=null,this._fsPath=null}return Object.defineProperty(e.prototype,"scheme",{get:function(){return this._scheme},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"authority",{get:function(){return this._authority},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"path",{get:function(){return this._path},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"query",{get:function(){return this._query},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fragment",{get:function(){return this._fragment},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"fsPath",{get:function(){if(!this._fsPath){var t;t=this._authority&&"file"===this.scheme?"//"+this._authority+this._path:e._driveLetterPath.test(this._path)?this._path[1].toLowerCase()+this._path.substr(2):this._path,r.isWindows&&(t=t.replace(/\//g,"\\")),this._fsPath=t}return this._fsPath},enumerable:!0,configurable:!0}),e.prototype["with"]=function(t,r,n,o,i){var a=new e;return a._scheme=t||this.scheme,a._authority=r||this.authority,a._path=n||this.path,a._query=o||this.query,a._fragment=i||this.fragment,e._validate(a),a},e.prototype.withScheme=function(e){return this["with"](e,void 0,void 0,void 0,void 0)},e.prototype.withAuthority=function(e){return this["with"](void 0,e,void 0,void 0,void 0)},e.prototype.withPath=function(e){return this["with"](void 0,void 0,e,void 0,void 0)},e.prototype.withQuery=function(e){return this["with"](void 0,void 0,void 0,e,void 0)},e.prototype.withFragment=function(e){return this["with"](void 0,void 0,void 0,void 0,e)},e.parse=function(t){var r=new e,n=e._parseComponents(t);return r._scheme=n.scheme,r._authority=decodeURIComponent(n.authority),r._path=decodeURIComponent(n.path),r._query=decodeURIComponent(n.query),r._fragment=decodeURIComponent(n.fragment),e._validate(r),r},e.file=function(t){var r=new e;if(r._scheme="file",t=t.replace(/\\/g,e._slash),t[0]===e._slash&&t[0]===t[1]){var n=t.indexOf(e._slash,2);-1===n?r._authority=t.substring(2):(r._authority=t.substring(2,n),r._path=t.substring(n))}else r._path=t;return r._path[0]!==e._slash&&(r._path=e._slash+r._path),e._validate(r),r},e._parseComponents=function(t){var r={scheme:e._empty,authority:e._empty,path:e._empty,query:e._empty,fragment:e._empty},n=e._regexp.exec(t);return n&&(r.scheme=n[2]||r.scheme,r.authority=n[4]||r.authority,r.path=n[5]||r.path,r.query=n[7]||r.query,r.fragment=n[9]||r.fragment),r},e.create=function(t,r,n,o,i){return(new e)["with"](t,r,n,o,i)},e._validate=function(e){if(e.authority&&e.path&&"/"!==e.path[0])throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character');if(!e.authority&&0===e.path.indexOf("//"))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')},e.prototype.toString=function(t){return void 0===t&&(t=!1),t?e._asFormatted(this,!0):(this._formatted||(this._formatted=e._asFormatted(this,!1)),this._formatted)},e._asFormatted=function(t,r){var a=r?i:o,s=[],u=t.scheme,c=t.authority,f=t.path,h=t.query,p=t.fragment;if(u&&s.push(u,":"),(c||"file"===u)&&s.push("//"),c){c=c.toLowerCase();var l=c.indexOf(":");-1===l?s.push(a(c)):s.push(a(c.substr(0,l)),c.substr(l))}if(f){var d=e._upperCaseDrive.exec(f);d&&(f=d[1]+d[2].toLowerCase()+f.substr(d[1].length+d[2].length));for(var y=0;;){var l=f.indexOf(e._slash,y);if(-1===l){s.push(a(f.substring(y)).replace(/[#?]/,n));break}s.push(a(f.substring(y,l)).replace(/[#?]/,n),e._slash),y=l+1}}return h&&s.push("?",a(h)),p&&s.push("#",a(p)),s.join(e._empty)},e.prototype.toJSON=function(){return{scheme:this.scheme,authority:this.authority,path:this.path,fsPath:this.fsPath,query:this.query,fragment:this.fragment.replace(/URL_MARSHAL_REMOVE.*$/,""),external:this.toString().replace(/#?URL_MARSHAL_REMOVE.*$/,""),$mid:1}},e.revive=function(t){var r=new e;return r._scheme=t.scheme,r._authority=t.authority,r._path=t.path,r._query=t.query,r._fragment=t.fragment,r._fsPath=t.fsPath,r._formatted=t.external,e._validate(r),r},e._empty="",e._slash="/",e._regexp=/^(([^:\/?#]+?):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/,e._driveLetterPath=/^\/[a-zA-z]:/,e._upperCaseDrive=/^(\/)?([A-Z]:)/,e}();Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=a}),define("vs/workbench/electron-main/package",["require","exports","path","vs/base/common/uri"],function(e,t,r,n){"use strict";var o=r.dirname(n["default"].parse(e.toUrl("")).fsPath),i=r.join(o,"package.json");Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=e.__$__nodeRequire(i)}),define("vs/workbench/electron-main/argv",["require","exports","os","minimist","./package"],function(e,t,r,n,o){"use strict";function i(e){return n(e,a)}var a={string:["locale","user-data-dir","extensionHomePath","extensionDevelopmentPath","extensionTestsPath","timestamp"],"boolean":["help","version","wait","diff","goto","new-window","reuse-window","performance","verbose","logExtensionHostCommunication","disable-extensions"],alias:{help:"h",version:"v",wait:"w",diff:"d","goto":"g","new-window":"n","reuse-window":"r",performance:"p","disable-extensions":"disableExtensions"}};t.parseArgs=i;var s="code"+("win32"===r.platform()?".exe":""),u="  ";t.helpMessage="Visual Studio Code v"+o["default"].version+"\n\nUsage: "+s+" [arguments] [paths...]\n\nOptions:\n"+u+"-d, --diff            Open a diff editor. Requires to pass two file paths\n"+u+"                      as arguments.\n"+u+"--disable-extensions  Disable all installed extensions.\n"+u+"-g, --goto            Open the file at path at the line and column (add\n"+u+"                      :line[:column] to path).\n"+u+"-h, --help            Print usage.\n"+u+"--locale <locale>     The locale to use (e.g. en-US or zh-TW).\n"+u+"-n, --new-window      Force a new instance of Code.\n"+u+"-r, --reuse-window    Force opening a file or folder in the last active\n"+u+"                      window.\n"+u+"--user-data-dir <dir> Specifies the directory that user data is kept in,\n"+u+"                      useful when running as root.\n"+u+"-v, --version         Print version.\n"+u+"-w, --wait            Wait for the window to be closed before returning."}),define("vs/workbench/electron-main/cli",["require","exports","child_process","vs/base/common/objects","./argv","./package"],function(e,t,r,n,o,i){"use strict";function a(e){var t=o.parseArgs(e);if(t.help)console.log(o.helpMessage);else if(t.version)console.log(i["default"].version);else{var a=n.assign({},process.env,{VSCODE_CLI:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});delete a.ATOM_SHELL_INTERNAL_RUN_AS_NODE;var s=r.spawn(process.execPath,e,{detached:!0,stdio:"ignore",env:a});if(t.wait)return void s.on("exit",process.exit)}process.exit(0)}t.main=a,a(process.argv.slice(2))});
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/c212f0908f3d29933317bbc3233568fbca7944b1/vs/workbench/electron-main/cli.js.map
